'\" t
.\"     Title: tor
.\"    Author: [see the "AUTHORS" section]
.\" Generator: DocBook XSL Stylesheets vsnapshot <http://docbook.sf.net/>
.\"      Date: 07/31/2017
.\"    Manual: Tor Manual
.\"    Source: Tor
.\"  Language: English
.\"
.TH "TOR" "1" "07/31/2017" "Tor" "Tor Manual"
.\" -----------------------------------------------------------------
.\" * Define some portability stuff
.\" -----------------------------------------------------------------
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" http://bugs.debian.org/507673
.\" http://lists.gnu.org/archive/html/groff/2009-02/msg00013.html
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.ie \n(.g .ds Aq \(aq
.el       .ds Aq '
.\" -----------------------------------------------------------------
.\" * set default formatting
.\" -----------------------------------------------------------------
.\" disable hyphenation
.nh
.\" disable justification (adjust text to left margin only)
.ad l
.\" -----------------------------------------------------------------
.\" * MAIN CONTENT STARTS HERE *
.\" -----------------------------------------------------------------
.SH "NAME"
tor \- The second\-generation onion router
.SH "SYNOPSIS"
.sp
\fBtor\fR [\fIOPTION\fR \fIvalue\fR]\&...
.SH "DESCRIPTION"
.sp
Tor is a connection\-oriented anonymizing communication service\&. Users choose a source\-routed path through a set of nodes, and negotiate a "virtual circuit" through the network, in which each node knows its predecessor and successor, but no others\&. Traffic flowing down the circuit is unwrapped by a symmetric key at each node, which reveals the downstream node\&.
.sp
Basically, Tor provides a distributed network of servers or relays ("onion routers")\&. Users bounce their TCP streams \(em web traffic, ftp, ssh, etc\&. \(em around the network, and recipients, observers, and even the relays themselves have difficulty tracking the source of the stream\&.
.sp
By default, \fBtor\fR will act as a client only\&. To help the network by providing bandwidth as a relay, change the \fBORPort\fR configuration option \(em see below\&. Please also consult the documentation on the Tor Project\(cqs website\&.
.SH "COMMAND\-LINE OPTIONS"
.PP
\fB\-h\fR, \fB\-help\fR
.RS 4
Display a short help message and exit\&.
.RE
.PP
\fB\-f\fR \fIFILE\fR
.RS 4
Specify a new configuration file to contain further Tor configuration options OR pass
\fB\-\fR
to make Tor read its configuration from standard input\&. (Default: @CONFDIR@/torrc, or $HOME/\&.torrc if that file is not found)
.RE
.PP
\fB\-\-allow\-missing\-torrc\fR
.RS 4
Do not require that configuration file specified by
\fB\-f\fR
exist if default torrc can be accessed\&.
.RE
.PP
\fB\-\-defaults\-torrc\fR \fIFILE\fR
.RS 4
Specify a file in which to find default values for Tor options\&. The contents of this file are overridden by those in the regular configuration file, and by those on the command line\&. (Default: @CONFDIR@/torrc\-defaults\&.)
.RE
.PP
\fB\-\-ignore\-missing\-torrc\fR
.RS 4
Specifies that Tor should treat a missing torrc file as though it were empty\&. Ordinarily, Tor does this for missing default torrc files, but not for those specified on the command line\&.
.RE
.PP
\fB\-\-hash\-password\fR \fIPASSWORD\fR
.RS 4
Generates a hashed password for control port access\&.
.RE
.PP
\fB\-\-list\-fingerprint\fR
.RS 4
Generate your keys and output your nickname and fingerprint\&.
.RE
.PP
\fB\-\-verify\-config\fR
.RS 4
Verify the configuration file is valid\&.
.RE
.PP
\fB\-\-service install\fR [\fB\-\-options\fR \fIcommand\-line options\fR]
.RS 4
Install an instance of Tor as a Windows service, with the provided command\-line options\&. Current instructions can be found at
https://www\&.torproject\&.org/docs/faq#NTService
.RE
.PP
\fB\-\-service\fR \fBremove\fR|\fBstart\fR|\fBstop\fR
.RS 4
Remove, start, or stop a configured Tor Windows service\&.
.RE
.PP
\fB\-\-nt\-service\fR
.RS 4
Used internally to implement a Windows service\&.
.RE
.PP
\fB\-\-list\-torrc\-options\fR
.RS 4
List all valid options\&.
.RE
.PP
\fB\-\-list\-deprecated\-options\fR
.RS 4
List all valid options that are scheduled to become obsolete in a future version\&. (This is a warning, not a promise\&.)
.RE
.PP
\fB\-\-version\fR
.RS 4
Display Tor version and exit\&.
.RE
.PP
\fB\-\-quiet\fR|\fB\-\-hush\fR
.RS 4
Override the default console log\&. By default, Tor starts out logging messages at level "notice" and higher to the console\&. It stops doing so after it parses its configuration, if the configuration tells it to log anywhere else\&. You can override this behavior with the
\fB\-\-hush\fR
option, which tells Tor to only send warnings and errors to the console, or with the
\fB\-\-quiet\fR
option, which tells Tor not to log to the console at all\&.
.RE
.PP
\fB\-\-keygen\fR [\fB\-\-newpass\fR]
.RS 4
Running "tor \-\-keygen" creates a new ed25519 master identity key for a relay, or only a fresh temporary signing key and certificate, if you already have a master key\&. Optionally you can encrypt the master identity key with a passphrase: Tor will ask you for one\&. If you don\(cqt want to encrypt the master key, just don\(cqt enter any passphrase when asked\&.


The
\fB\-\-newpass\fR
option should be used with \-\-keygen only when you need to add, change, or remove a passphrase on an existing ed25519 master identity key\&. You will be prompted for the old passphase (if any), and the new passphrase (if any)\&.


When generating a master key, you will probably want to use
\fB\-\-DataDirectory\fR
to control where the keys and certificates will be stored, and
\fB\-\-SigningKeyLifetime\fR
to control their lifetimes\&. Their behavior is as documented in the server options section below\&. (You must have write access to the specified DataDirectory\&.)


To use the generated files, you must copy them to the DataDirectory/keys directory of your Tor daemon, and make sure that they are owned by the user actually running the Tor daemon on your system\&.
.RE
.PP
\fB\-\-passphrase\-fd\fR \fIFILEDES\fR
.RS 4
Filedescriptor to read the passphrase from\&. Note that unlike with the tor\-gencert program, the entire file contents are read and used as the passphrase, including any trailing newlines\&. Default: read from the terminal\&.
.RE
.sp
Other options can be specified on the command\-line in the format "\-\-option value", in the format "option value", or in a configuration file\&. For instance, you can tell Tor to start listening for SOCKS connections on port 9999 by passing \-\-SocksPort 9999 or SocksPort 9999 to it on the command line, or by putting "SocksPort 9999" in the configuration file\&. You will need to quote options with spaces in them: if you want Tor to log all debugging messages to debug\&.log, you will probably need to say \-\-Log \fIdebug file debug\&.log\fR\&.
.sp
Options on the command line override those in configuration files\&. See the next section for more information\&.
.SH "THE CONFIGURATION FILE FORMAT"
.sp
All configuration options in a configuration are written on a single line by default\&. They take the form of an option name and a value, or an option name and a quoted value (option value or option "value")\&. Anything after a # character is treated as a comment\&. Options are case\-insensitive\&. C\-style escaped characters are allowed inside quoted values\&. To split one configuration entry into multiple lines, use a single backslash character (\e) before the end of the line\&. Comments can be used in such multiline entries, but they must start at the beginning of a line\&.
.sp
Configuration options can be imported from files or folders using the %include option with the value being a path\&. If the path is a file, the options from the file will be parsed as if they were written where the %include option is\&. If the path is a folder, all files on that folder will be parsed following lexical order\&. Files starting with a dot are ignored\&. Files on subfolders are ignored\&. The %include option can be used recursively\&.
.sp
By default, an option on the command line overrides an option found in the configuration file, and an option in a configuration file overrides one in the defaults file\&.
.sp
This rule is simple for options that take a single value, but it can become complicated for options that are allowed to occur more than once: if you specify four SocksPorts in your configuration file, and one more SocksPort on the command line, the option on the command line will replace \fIall\fR of the SocksPorts in the configuration file\&. If this isn\(cqt what you want, prefix the option name with a plus sign (+), and it will be appended to the previous set of options instead\&. For example, setting SocksPort 9100 will use only port 9100, but setting +SocksPort 9100 will use ports 9100 and 9050 (because this is the default)\&.
.sp
Alternatively, you might want to remove every instance of an option in the configuration file, and not replace it at all: you might want to say on the command line that you want no SocksPorts at all\&. To do that, prefix the option name with a forward slash (/)\&. You can use the plus sign (+) and the forward slash (/) in the configuration file and on the command line\&.
.SH "GENERAL OPTIONS"
.PP
\fBBandwidthRate\fR \fIN\fR \fBbytes\fR|\fBKBytes\fR|\fBMBytes\fR|\fBGBytes\fR|\fBTBytes\fR|\fBKBits\fR|\fBMBits\fR|\fBGBits\fR|\fBTBits\fR
.RS 4
A token bucket limits the average incoming bandwidth usage on this node to the specified number of bytes per second, and the average outgoing bandwidth usage to that same value\&. If you want to run a relay in the public network, this needs to be
\fIat the very least\fR
75 KBytes for a relay (that is, 600 kbits) or 50 KBytes for a bridge (400 kbits) \(em but of course, more is better; we recommend at least 250 KBytes (2 mbits) if possible\&. (Default: 1 GByte)


Note that this option, and other bandwidth\-limiting options, apply to TCP data only: They do not count TCP headers or DNS traffic\&.


With this option, and in other options that take arguments in bytes, KBytes, and so on, other formats are also supported\&. Notably, "KBytes" can also be written as "kilobytes" or "kb"; "MBytes" can be written as "megabytes" or "MB"; "kbits" can be written as "kilobits"; and so forth\&. Tor also accepts "byte" and "bit" in the singular\&. The prefixes "tera" and "T" are also recognized\&. If no units are given, we default to bytes\&. To avoid confusion, we recommend writing "bytes" or "bits" explicitly, since it\(cqs easy to forget that "B" means bytes, not bits\&.
.RE
.PP
\fBBandwidthBurst\fR \fIN\fR \fBbytes\fR|\fBKBytes\fR|\fBMBytes\fR|\fBGBytes\fR|\fBTBytes\fR|\fBKBits\fR|\fBMBits\fR|\fBGBits\fR|\fBTBits\fR
.RS 4
Limit the maximum token bucket size (also known as the burst) to the given number of bytes in each direction\&. (Default: 1 GByte)
.RE
.PP
\fBMaxAdvertisedBandwidth\fR \fIN\fR \fBbytes\fR|\fBKBytes\fR|\fBMBytes\fR|\fBGBytes\fR|\fBTBytes\fR|\fBKBits\fR|\fBMBits\fR|\fBGBits\fR|\fBTBits\fR
.RS 4
If set, we will not advertise more than this amount of bandwidth for our BandwidthRate\&. Server operators who want to reduce the number of clients who ask to build circuits through them (since this is proportional to advertised bandwidth rate) can thus reduce the CPU demands on their server without impacting network performance\&.
.RE
.PP
\fBRelayBandwidthRate\fR \fIN\fR \fBbytes\fR|\fBKBytes\fR|\fBMBytes\fR|\fBGBytes\fR|\fBTBytes\fR|\fBKBits\fR|\fBMBits\fR|\fBGBits\fR|\fBTBits\fR
.RS 4
If not 0, a separate token bucket limits the average incoming bandwidth usage for _relayed traffic_ on this node to the specified number of bytes per second, and the average outgoing bandwidth usage to that same value\&. Relayed traffic currently is calculated to include answers to directory requests, but that may change in future versions\&. (Default: 0)
.RE
.PP
\fBRelayBandwidthBurst\fR \fIN\fR \fBbytes\fR|\fBKBytes\fR|\fBMBytes\fR|\fBGBytes\fR|\fBTBytes\fR|\fBKBits\fR|\fBMBits\fR|\fBGBits\fR|\fBTBits\fR
.RS 4
If not 0, limit the maximum token bucket size (also known as the burst) for _relayed traffic_ to the given number of bytes in each direction\&. (Default: 0)
.RE
.PP
\fBPerConnBWRate\fR \fIN\fR \fBbytes\fR|\fBKBytes\fR|\fBMBytes\fR|\fBGBytes\fR|\fBTBytes\fR|\fBKBits\fR|\fBMBits\fR|\fBGBits\fR|\fBTBits\fR
.RS 4
If set, do separate rate limiting for each connection from a non\-relay\&. You should never need to change this value, since a network\-wide value is published in the consensus and your relay will use that value\&. (Default: 0)
.RE
.PP
\fBPerConnBWBurst\fR \fIN\fR \fBbytes\fR|\fBKBytes\fR|\fBMBytes\fR|\fBGBytes\fR|\fBTBytes\fR|\fBKBits\fR|\fBMBits\fR|\fBGBits\fR|\fBTBits\fR
.RS 4
If set, do separate rate limiting for each connection from a non\-relay\&. You should never need to change this value, since a network\-wide value is published in the consensus and your relay will use that value\&. (Default: 0)
.RE
.PP
\fBClientTransportPlugin\fR \fItransport\fR socks4|socks5 \fIIP\fR:\fIPORT\fR, \fBClientTransportPlugin\fR \fItransport\fR exec \fIpath\-to\-binary\fR [options]
.RS 4
In its first form, when set along with a corresponding Bridge line, the Tor client forwards its traffic to a SOCKS\-speaking proxy on "IP:PORT"\&. It\(cqs the duty of that proxy to properly forward the traffic to the bridge\&.


In its second form, when set along with a corresponding Bridge line, the Tor client launches the pluggable transport proxy executable in
\fIpath\-to\-binary\fR
using
\fIoptions\fR
as its command\-line options, and forwards its traffic to it\&. It\(cqs the duty of that proxy to properly forward the traffic to the bridge\&.
.RE
.PP
\fBServerTransportPlugin\fR \fItransport\fR exec \fIpath\-to\-binary\fR [options]
.RS 4
The Tor relay launches the pluggable transport proxy in
\fIpath\-to\-binary\fR
using
\fIoptions\fR
as its command\-line options, and expects to receive proxied client traffic from it\&.
.RE
.PP
\fBServerTransportListenAddr\fR \fItransport\fR \fIIP\fR:\fIPORT\fR
.RS 4
When this option is set, Tor will suggest
\fIIP\fR:\fIPORT\fR
as the listening address of any pluggable transport proxy that tries to launch
\fItransport\fR\&.
.RE
.PP
\fBServerTransportOptions\fR \fItransport\fR \fIk=v\fR \fIk=v\fR \&...
.RS 4
When this option is set, Tor will pass the
\fIk=v\fR
parameters to any pluggable transport proxy that tries to launch
\fItransport\fR\&.

(Example: ServerTransportOptions obfs45 shared\-secret=bridgepasswd cache=/var/lib/tor/cache)
.RE
.PP
\fBExtORPort\fR [\fIaddress\fR:]\fIport\fR|\fBauto\fR
.RS 4
Open this port to listen for Extended ORPort connections from your pluggable transports\&.
.RE
.PP
\fBExtORPortCookieAuthFile\fR \fIPath\fR
.RS 4
If set, this option overrides the default location and file name for the Extended ORPort\(cqs cookie file \(em the cookie file is needed for pluggable transports to communicate through the Extended ORPort\&.
.RE
.PP
\fBExtORPortCookieAuthFileGroupReadable\fR \fB0\fR|\fB1\fR
.RS 4
If this option is set to 0, don\(cqt allow the filesystem group to read the Extended OR Port cookie file\&. If the option is set to 1, make the cookie file readable by the default GID\&. [Making the file readable by other groups is not yet implemented; let us know if you need this for some reason\&.] (Default: 0)
.RE
.PP
\fBConnLimit\fR \fINUM\fR
.RS 4
The minimum number of file descriptors that must be available to the Tor process before it will start\&. Tor will ask the OS for as many file descriptors as the OS will allow (you can find this by "ulimit \-H \-n")\&. If this number is less than ConnLimit, then Tor will refuse to start\&.


You probably don\(cqt need to adjust this\&. It has no effect on Windows since that platform lacks getrlimit()\&. (Default: 1000)
.RE
.PP
\fBDisableNetwork\fR \fB0\fR|\fB1\fR
.RS 4
When this option is set, we don\(cqt listen for or accept any connections other than controller connections, and we close (and don\(cqt reattempt) any outbound connections\&. Controllers sometimes use this option to avoid using the network until Tor is fully configured\&. (Default: 0)
.RE
.PP
\fBConstrainedSockets\fR \fB0\fR|\fB1\fR
.RS 4
If set, Tor will tell the kernel to attempt to shrink the buffers for all sockets to the size specified in
\fBConstrainedSockSize\fR\&. This is useful for virtual servers and other environments where system level TCP buffers may be limited\&. If you\(cqre on a virtual server, and you encounter the "Error creating network socket: No buffer space available" message, you are likely experiencing this problem\&.


The preferred solution is to have the admin increase the buffer pool for the host itself via /proc/sys/net/ipv4/tcp_mem or equivalent facility; this configuration option is a second\-resort\&.


The DirPort option should also not be used if TCP buffers are scarce\&. The cached directory requests consume additional sockets which exacerbates the problem\&.


You should
\fBnot\fR
enable this feature unless you encounter the "no buffer space available" issue\&. Reducing the TCP buffers affects window size for the TCP stream and will reduce throughput in proportion to round trip time on long paths\&. (Default: 0)
.RE
.PP
\fBConstrainedSockSize\fR \fIN\fR \fBbytes\fR|\fBKBytes\fR
.RS 4
When
\fBConstrainedSockets\fR
is enabled the receive and transmit buffers for all sockets will be set to this limit\&. Must be a value between 2048 and 262144, in 1024 byte increments\&. Default of 8192 is recommended\&.
.RE
.PP
\fBControlPort\fR \fIPORT\fR|\fBunix:\fR\fIpath\fR|\fBauto\fR [\fIflags\fR]
.RS 4
If set, Tor will accept connections on this port and allow those connections to control the Tor process using the Tor Control Protocol (described in control\-spec\&.txt in
torspec)\&. Note: unless you also specify one or more of
\fBHashedControlPassword\fR
or
\fBCookieAuthentication\fR, setting this option will cause Tor to allow any process on the local host to control it\&. (Setting both authentication methods means either method is sufficient to authenticate to Tor\&.) This option is required for many Tor controllers; most use the value of 9051\&. If a unix domain socket is used, you may quote the path using standard C escape sequences\&. Set it to "auto" to have Tor pick a port for you\&. (Default: 0)


Recognized flags are\&...
.PP
\fBGroupWritable\fR
.RS 4
Unix domain sockets only: makes the socket get created as group\-writable\&.
.RE
.PP
\fBWorldWritable\fR
.RS 4
Unix domain sockets only: makes the socket get created as world\-writable\&.
.RE
.PP
\fBRelaxDirModeCheck\fR
.RS 4
Unix domain sockets only: Do not insist that the directory that holds the socket be read\-restricted\&.
.RE
.RE
.PP
\fBControlSocket\fR \fIPath\fR
.RS 4
Like ControlPort, but listens on a Unix domain socket, rather than a TCP socket\&.
\fI0\fR
disables ControlSocket (Unix and Unix\-like systems only\&.)
.RE
.PP
\fBControlSocketsGroupWritable\fR \fB0\fR|\fB1\fR
.RS 4
If this option is set to 0, don\(cqt allow the filesystem group to read and write unix sockets (e\&.g\&. ControlSocket)\&. If the option is set to 1, make the control socket readable and writable by the default GID\&. (Default: 0)
.RE
.PP
\fBHashedControlPassword\fR \fIhashed_password\fR
.RS 4
Allow connections on the control port if they present the password whose one\-way hash is
\fIhashed_password\fR\&. You can compute the hash of a password by running "tor \-\-hash\-password
\fIpassword\fR"\&. You can provide several acceptable passwords by using more than one HashedControlPassword line\&.
.RE
.PP
\fBCookieAuthentication\fR \fB0\fR|\fB1\fR
.RS 4
If this option is set to 1, allow connections on the control port when the connecting process knows the contents of a file named "control_auth_cookie", which Tor will create in its data directory\&. This authentication method should only be used on systems with good filesystem security\&. (Default: 0)
.RE
.PP
\fBCookieAuthFile\fR \fIPath\fR
.RS 4
If set, this option overrides the default location and file name for Tor\(cqs cookie file\&. (See CookieAuthentication above\&.)
.RE
.PP
\fBCookieAuthFileGroupReadable\fR \fB0\fR|\fB1\fR
.RS 4
If this option is set to 0, don\(cqt allow the filesystem group to read the cookie file\&. If the option is set to 1, make the cookie file readable by the default GID\&. [Making the file readable by other groups is not yet implemented; let us know if you need this for some reason\&.] (Default: 0)
.RE
.PP
\fBControlPortWriteToFile\fR \fIPath\fR
.RS 4
If set, Tor writes the address and port of any control port it opens to this address\&. Usable by controllers to learn the actual control port when ControlPort is set to "auto"\&.
.RE
.PP
\fBControlPortFileGroupReadable\fR \fB0\fR|\fB1\fR
.RS 4
If this option is set to 0, don\(cqt allow the filesystem group to read the control port file\&. If the option is set to 1, make the control port file readable by the default GID\&. (Default: 0)
.RE
.PP
\fBDataDirectory\fR \fIDIR\fR
.RS 4
Store working data in DIR\&. Can not be changed while tor is running\&. (Default: ~/\&.tor if your home directory is not /; otherwise, @LOCALSTATEDIR@/lib/tor\&. On Windows, the default is your ApplicationData folder\&.)
.RE
.PP
\fBDataDirectoryGroupReadable\fR \fB0\fR|\fB1\fR
.RS 4
If this option is set to 0, don\(cqt allow the filesystem group to read the DataDirectory\&. If the option is set to 1, make the DataDirectory readable by the default GID\&. (Default: 0)
.RE
.PP
\fBFallbackDir\fR \fIaddress\fR:\fIport\fR orport=\fIport\fR id=\fIfingerprint\fR [weight=\fInum\fR] [ipv6=\fIaddress\fR:\fIorport\fR]
.RS 4
When we\(cqre unable to connect to any directory cache for directory info (usually because we don\(cqt know about any yet) we try a directory authority\&. Clients also simultaneously try a FallbackDir, to avoid hangs on client startup if a directory authority is down\&. Clients retry FallbackDirs more often than directory authorities, to reduce the load on the directory authorities\&. By default, the directory authorities are also FallbackDirs\&. Specifying a FallbackDir replaces Tor\(cqs default hard\-coded FallbackDirs (if any)\&. (See the
\fBDirAuthority\fR
entry for an explanation of each flag\&.)
.RE
.PP
\fBUseDefaultFallbackDirs\fR \fB0\fR|\fB1\fR
.RS 4
Use Tor\(cqs default hard\-coded FallbackDirs (if any)\&. (When a FallbackDir line is present, it replaces the hard\-coded FallbackDirs, regardless of the value of UseDefaultFallbackDirs\&.) (Default: 1)
.RE
.PP
\fBDirAuthority\fR [\fInickname\fR] [\fBflags\fR] \fIaddress\fR:\fIport\fR \fIfingerprint\fR
.RS 4
Use a nonstandard authoritative directory server at the provided address and port, with the specified key fingerprint\&. This option can be repeated many times, for multiple authoritative directory servers\&. Flags are separated by spaces, and determine what kind of an authority this directory is\&. By default, an authority is not authoritative for any directory style or version unless an appropriate flag is given\&. Tor will use this authority as a bridge authoritative directory if the "bridge" flag is set\&. If a flag "orport=\fBport\fR" is given, Tor will use the given port when opening encrypted tunnels to the dirserver\&. If a flag "weight=\fBnum\fR" is given, then the directory server is chosen randomly with probability proportional to that weight (default 1\&.0)\&. If a flag "v3ident=\fBfp\fR" is given, the dirserver is a v3 directory authority whose v3 long\-term signing key has the fingerprint
\fBfp\fR\&. Lastly, if an "ipv6=\fIaddress\fR:\fIorport\fR" flag is present, then the directory authority is listening for IPv6 connections on the indicated IPv6 address and OR Port\&.


Tor will contact the authority at
\fIaddress\fR:\fIport\fR
(the DirPort) to download directory documents\&. If an IPv6 address is supplied, Tor will also download directory documents at the IPv6 address on the DirPort\&.


If no
\fBDirAuthority\fR
line is given, Tor will use the default directory authorities\&. NOTE: this option is intended for setting up a private Tor network with its own directory authorities\&. If you use it, you will be distinguishable from other users, because you won\(cqt believe the same authorities they do\&.
.RE
.PP
\fBDirAuthorityFallbackRate\fR \fINUM\fR
.RS 4
When configured to use both directory authorities and fallback directories, the directory authorities also work as fallbacks\&. They are chosen with their regular weights, multiplied by this number, which should be 1\&.0 or less\&. (Default: 1\&.0)
.RE
.sp
\fBAlternateDirAuthority\fR [\fInickname\fR] [\fBflags\fR] \fIaddress\fR:\fIport\fR \fIfingerprint\fR
.PP
\fBAlternateBridgeAuthority\fR [\fInickname\fR] [\fBflags\fR] \fIaddress\fR:\fIport\fR \fI fingerprint\fR
.RS 4
These options behave as DirAuthority, but they replace fewer of the default directory authorities\&. Using AlternateDirAuthority replaces the default Tor directory authorities, but leaves the default bridge authorities in place\&. Similarly, AlternateBridgeAuthority replaces the default bridge authority, but leaves the directory authorities alone\&.
.RE
.PP
\fBDisableAllSwap\fR \fB0\fR|\fB1\fR
.RS 4
If set to 1, Tor will attempt to lock all current and future memory pages, so that memory cannot be paged out\&. Windows, OS X and Solaris are currently not supported\&. We believe that this feature works on modern Gnu/Linux distributions, and that it should work on *BSD systems (untested)\&. This option requires that you start your Tor as root, and you should use the
\fBUser\fR
option to properly reduce Tor\(cqs privileges\&. Can not be changed while tor is running\&. (Default: 0)
.RE
.PP
\fBDisableDebuggerAttachment\fR \fB0\fR|\fB1\fR
.RS 4
If set to 1, Tor will attempt to prevent basic debugging attachment attempts by other processes\&. This may also keep Tor from generating core files if it crashes\&. It has no impact for users who wish to attach if they have CAP_SYS_PTRACE or if they are root\&. We believe that this feature works on modern Gnu/Linux distributions, and that it may also work on *BSD systems (untested)\&. Some modern Gnu/Linux systems such as Ubuntu have the kernel\&.yama\&.ptrace_scope sysctl and by default enable it as an attempt to limit the PTRACE scope for all user processes by default\&. This feature will attempt to limit the PTRACE scope for Tor specifically \- it will not attempt to alter the system wide ptrace scope as it may not even exist\&. If you wish to attach to Tor with a debugger such as gdb or strace you will want to set this to 0 for the duration of your debugging\&. Normal users should leave it on\&. Disabling this option while Tor is running is prohibited\&. (Default: 1)
.RE
.PP
\fBFetchDirInfoEarly\fR \fB0\fR|\fB1\fR
.RS 4
If set to 1, Tor will always fetch directory information like other directory caches, even if you don\(cqt meet the normal criteria for fetching early\&. Normal users should leave it off\&. (Default: 0)
.RE
.PP
\fBFetchDirInfoExtraEarly\fR \fB0\fR|\fB1\fR
.RS 4
If set to 1, Tor will fetch directory information before other directory caches\&. It will attempt to download directory information closer to the start of the consensus period\&. Normal users should leave it off\&. (Default: 0)
.RE
.PP
\fBFetchHidServDescriptors\fR \fB0\fR|\fB1\fR
.RS 4
If set to 0, Tor will never fetch any hidden service descriptors from the rendezvous directories\&. This option is only useful if you\(cqre using a Tor controller that handles hidden service fetches for you\&. (Default: 1)
.RE
.PP
\fBFetchServerDescriptors\fR \fB0\fR|\fB1\fR
.RS 4
If set to 0, Tor will never fetch any network status summaries or server descriptors from the directory servers\&. This option is only useful if you\(cqre using a Tor controller that handles directory fetches for you\&. (Default: 1)
.RE
.PP
\fBFetchUselessDescriptors\fR \fB0\fR|\fB1\fR
.RS 4
If set to 1, Tor will fetch every consensus flavor, descriptor, and certificate that it hears about\&. Otherwise, it will avoid fetching useless descriptors: flavors that it is not using to build circuits, and authority certificates it does not trust\&. This option is useful if you\(cqre using a tor client with an external parser that uses a full consensus\&. This option fetches all documents,
\fBDirCache\fR
fetches and serves all documents\&. (Default: 0)
.RE
.PP
\fBHTTPProxy\fR \fIhost\fR[:\fIport\fR]
.RS 4
Tor will make all its directory requests through this host:port (or host:80 if port is not specified), rather than connecting directly to any directory servers\&.
.RE
.PP
\fBHTTPProxyAuthenticator\fR \fIusername:password\fR
.RS 4
If defined, Tor will use this username:password for Basic HTTP proxy authentication, as in RFC 2617\&. This is currently the only form of HTTP proxy authentication that Tor supports; feel free to submit a patch if you want it to support others\&.
.RE
.PP
\fBHTTPSProxy\fR \fIhost\fR[:\fIport\fR]
.RS 4
Tor will make all its OR (SSL) connections through this host:port (or host:443 if port is not specified), via HTTP CONNECT rather than connecting directly to servers\&. You may want to set
\fBFascistFirewall\fR
to restrict the set of ports you might try to connect to, if your HTTPS proxy only allows connecting to certain ports\&.
.RE
.PP
\fBHTTPSProxyAuthenticator\fR \fIusername:password\fR
.RS 4
If defined, Tor will use this username:password for Basic HTTPS proxy authentication, as in RFC 2617\&. This is currently the only form of HTTPS proxy authentication that Tor supports; feel free to submit a patch if you want it to support others\&.
.RE
.PP
\fBSandbox\fR \fB0\fR|\fB1\fR
.RS 4
If set to 1, Tor will run securely through the use of a syscall sandbox\&. Otherwise the sandbox will be disabled\&. The option is currently an experimental feature\&. Can not be changed while tor is running\&.
.sp
.if n \{\
.RS 4
.\}
.nf
When the Sandbox is 1, the following options can not be changed when tor
is running:
Address
ConnLimit
CookieAuthFile
DirPortFrontPage
ExtORPortCookieAuthFile
Logs
ServerDNSResolvConfFile
Tor must remain in client or server mode (some changes to ClientOnly and
ORPort are not allowed)\&.
(Default: 0)
.fi
.if n \{\
.RE
.\}
.RE
.PP
\fBSocks4Proxy\fR \fIhost\fR[:\fIport\fR]
.RS 4
Tor will make all OR connections through the SOCKS 4 proxy at host:port (or host:1080 if port is not specified)\&.
.RE
.PP
\fBSocks5Proxy\fR \fIhost\fR[:\fIport\fR]
.RS 4
Tor will make all OR connections through the SOCKS 5 proxy at host:port (or host:1080 if port is not specified)\&.
.RE
.sp
\fBSocks5ProxyUsername\fR \fIusername\fR
.PP
\fBSocks5ProxyPassword\fR \fIpassword\fR
.RS 4
If defined, authenticate to the SOCKS 5 server using username and password in accordance to RFC 1929\&. Both username and password must be between 1 and 255 characters\&.
.RE
.PP
\fBSocksSocketsGroupWritable\fR \fB0\fR|\fB1\fR
.RS 4
If this option is set to 0, don\(cqt allow the filesystem group to read and write unix sockets (e\&.g\&. SocksSocket)\&. If the option is set to 1, make the SocksSocket socket readable and writable by the default GID\&. (Default: 0)
.RE
.PP
\fBKeepalivePeriod\fR \fINUM\fR
.RS 4
To keep firewalls from expiring connections, send a padding keepalive cell every NUM seconds on open connections that are in use\&. If the connection has no open circuits, it will instead be closed after NUM seconds of idleness\&. (Default: 5 minutes)
.RE
.PP
\fBLog\fR \fIminSeverity\fR[\-\fImaxSeverity\fR] \fBstderr\fR|\fBstdout\fR|\fBsyslog\fR
.RS 4
Send all messages between
\fIminSeverity\fR
and
\fImaxSeverity\fR
to the standard output stream, the standard error stream, or to the system log\&. (The "syslog" value is only supported on Unix\&.) Recognized severity levels are debug, info, notice, warn, and err\&. We advise using "notice" in most cases, since anything more verbose may provide sensitive information to an attacker who obtains the logs\&. If only one severity level is given, all messages of that level or higher will be sent to the listed destination\&.
.RE
.PP
\fBLog\fR \fIminSeverity\fR[\-\fImaxSeverity\fR] \fBfile\fR \fIFILENAME\fR
.RS 4
As above, but send log messages to the listed filename\&. The "Log" option may appear more than once in a configuration file\&. Messages are sent to all the logs that match their severity level\&.
.RE
.sp
\fBLog\fR \fB[\fR\fIdomain\fR,\&...\fB]\fR\fIminSeverity\fR[\-\fImaxSeverity\fR] \&... \fBfile\fR \fIFILENAME\fR
.PP
\fBLog\fR \fB[\fR\fIdomain\fR,\&...\fB]\fR\fIminSeverity\fR[\-\fImaxSeverity\fR] \&... \fBstderr\fR|\fBstdout\fR|\fBsyslog\fR
.RS 4
As above, but select messages by range of log severity
\fIand\fR
by a set of "logging domains"\&. Each logging domain corresponds to an area of functionality inside Tor\&. You can specify any number of severity ranges for a single log statement, each of them prefixed by a comma\-separated list of logging domains\&. You can prefix a domain with ~ to indicate negation, and use * to indicate "all domains"\&. If you specify a severity range without a list of domains, it matches all domains\&.


This is an advanced feature which is most useful for debugging one or two of Tor\(cqs subsystems at a time\&.


The currently recognized domains are: general, crypto, net, config, fs, protocol, mm, http, app, control, circ, rend, bug, dir, dirserv, or, edge, acct, hist, and handshake\&. Domain names are case\-insensitive\&.


For example, "Log [handshake]debug [~net,~mm]info notice stdout" sends to stdout: all handshake messages of any severity, all info\-and\-higher messages from domains other than networking and memory management, and all messages of severity notice or higher\&.
.RE
.PP
\fBLogMessageDomains\fR \fB0\fR|\fB1\fR
.RS 4
If 1, Tor includes message domains with each log message\&. Every log message currently has at least one domain; most currently have exactly one\&. This doesn\(cqt affect controller log messages\&. (Default: 0)
.RE
.PP
\fBMaxUnparseableDescSizeToLog\fR \fIN\fR \fBbytes\fR|\fBKBytes\fR|\fBMBytes\fR|\fBGBytes\fR|\fBTBytes\fR
.RS 4
Unparseable descriptors (e\&.g\&. for votes, consensuses, routers) are logged in separate files by hash, up to the specified size in total\&. Note that only files logged during the lifetime of this Tor process count toward the total; this is intended to be used to debug problems without opening live servers to resource exhaustion attacks\&. (Default: 10 MB)
.RE
.PP
\fBOutboundBindAddress\fR \fIIP\fR
.RS 4
Make all outbound connections originate from the IP address specified\&. This is only useful when you have multiple network interfaces, and you want all of Tor\(cqs outgoing connections to use a single one\&. This option may be used twice, once with an IPv4 address and once with an IPv6 address\&. This setting will be ignored for connections to the loopback addresses (127\&.0\&.0\&.0/8 and ::1)\&.
.RE
.PP
\fBOutboundBindAddressOR\fR \fIIP\fR
.RS 4
Make all outbound non\-exit (relay and other) connections originate from the IP address specified\&. This option overrides
\fBOutboundBindAddress\fR
for the same IP version\&. This option may be used twice, once with an IPv4 address and once with an IPv6 address\&. This setting will be ignored for connections to the loopback addresses (127\&.0\&.0\&.0/8 and ::1)\&.
.RE
.PP
\fBOutboundBindAddressExit\fR \fIIP\fR
.RS 4
Make all outbound exit connections originate from the IP address specified\&. This option overrides
\fBOutboundBindAddress\fR
for the same IP version\&. This option may be used twice, once with an IPv4 address and once with an IPv6 address\&. This setting will be ignored for connections to the loopback addresses (127\&.0\&.0\&.0/8 and ::1)\&.
.RE
.PP
\fBPidFile\fR \fIFILE\fR
.RS 4
On startup, write our PID to FILE\&. On clean shutdown, remove FILE\&. Can not be changed while tor is running\&.
.RE
.PP
\fBProtocolWarnings\fR \fB0\fR|\fB1\fR
.RS 4
If 1, Tor will log with severity \*(Aqwarn\*(Aq various cases of other parties not following the Tor specification\&. Otherwise, they are logged with severity \*(Aqinfo\*(Aq\&. (Default: 0)
.RE
.PP
\fBRunAsDaemon\fR \fB0\fR|\fB1\fR
.RS 4
If 1, Tor forks and daemonizes to the background\&. This option has no effect on Windows; instead you should use the \-\-service command\-line option\&. Can not be changed while tor is running\&. (Default: 0)
.RE
.PP
\fBLogTimeGranularity\fR \fINUM\fR
.RS 4
Set the resolution of timestamps in Tor\(cqs logs to NUM milliseconds\&. NUM must be positive and either a divisor or a multiple of 1 second\&. Note that this option only controls the granularity written by Tor to a file or console log\&. Tor does not (for example) "batch up" log messages to affect times logged by a controller, times attached to syslog messages, or the mtime fields on log files\&. (Default: 1 second)
.RE
.PP
\fBTruncateLogFile\fR \fB0\fR|\fB1\fR
.RS 4
If 1, Tor will overwrite logs at startup and in response to a HUP signal, instead of appending to them\&. (Default: 0)
.RE
.PP
\fBSyslogIdentityTag\fR \fItag\fR
.RS 4
When logging to syslog, adds a tag to the syslog identity such that log entries are marked with "Tor\-\fItag\fR"\&. Can not be changed while tor is running\&. (Default: none)
.RE
.PP
\fBSafeLogging\fR \fB0\fR|\fB1\fR|\fBrelay\fR
.RS 4
Tor can scrub potentially sensitive strings from log messages (e\&.g\&. addresses) by replacing them with the string [scrubbed]\&. This way logs can still be useful, but they don\(cqt leave behind personally identifying information about what sites a user might have visited\&.


If this option is set to 0, Tor will not perform any scrubbing, if it is set to 1, all potentially sensitive strings are replaced\&. If it is set to relay, all log messages generated when acting as a relay are sanitized, but all messages generated when acting as a client are not\&. (Default: 1)
.RE
.PP
\fBUser\fR \fIUsername\fR
.RS 4
On startup, setuid to this user and setgid to their primary group\&. Can not be changed while tor is running\&.
.RE
.PP
\fBKeepBindCapabilities\fR \fB0\fR|\fB1\fR|\fBauto\fR
.RS 4
On Linux, when we are started as root and we switch our identity using the
\fBUser\fR
option, the
\fBKeepBindCapabilities\fR
option tells us whether to try to retain our ability to bind to low ports\&. If this value is 1, we try to keep the capability; if it is 0 we do not; and if it is
\fBauto\fR, we keep the capability only if we are configured to listen on a low port\&. Can not be changed while tor is running\&. (Default: auto\&.)
.RE
.PP
\fBHardwareAccel\fR \fB0\fR|\fB1\fR
.RS 4
If non\-zero, try to use built\-in (static) crypto hardware acceleration when available\&. Can not be changed while tor is running\&. (Default: 0)
.RE
.PP
\fBAccelName\fR \fINAME\fR
.RS 4
When using OpenSSL hardware crypto acceleration attempt to load the dynamic engine of this name\&. This must be used for any dynamic hardware engine\&. Names can be verified with the openssl engine command\&. Can not be changed while tor is running\&.
.RE
.PP
\fBAccelDir\fR \fIDIR\fR
.RS 4
Specify this option if using dynamic hardware acceleration and the engine implementation library resides somewhere other than the OpenSSL default\&. Can not be changed while tor is running\&.
.RE
.PP
\fBAvoidDiskWrites\fR \fB0\fR|\fB1\fR
.RS 4
If non\-zero, try to write to disk less frequently than we would otherwise\&. This is useful when running on flash memory or other media that support only a limited number of writes\&. (Default: 0)
.RE
.PP
\fBCircuitPriorityHalflife\fR \fINUM1\fR
.RS 4
If this value is set, we override the default algorithm for choosing which circuit\(cqs cell to deliver or relay next\&. When the value is 0, we round\-robin between the active circuits on a connection, delivering one cell from each in turn\&. When the value is positive, we prefer delivering cells from whichever connection has the lowest weighted cell count, where cells are weighted exponentially according to the supplied CircuitPriorityHalflife value (in seconds)\&. If this option is not set at all, we use the behavior recommended in the current consensus networkstatus\&. This is an advanced option; you generally shouldn\(cqt have to mess with it\&. (Default: not set)
.RE
.PP
\fBCountPrivateBandwidth\fR \fB0\fR|\fB1\fR
.RS 4
If this option is set, then Tor\(cqs rate\-limiting applies not only to remote connections, but also to connections to private addresses like 127\&.0\&.0\&.1 or 10\&.0\&.0\&.1\&. This is mostly useful for debugging rate\-limiting\&. (Default: 0)
.RE
.PP
\fBExtendByEd25519ID\fR \fB0\fR|\fB1\fR|\fBauto\fR
.RS 4
If this option is set to 1, we always try to include a relay\(cqs Ed25519 ID when telling the proceeding relay in a circuit to extend to it\&. If this option is set to 0, we never include Ed25519 IDs when extending circuits\&. If the option is set to "default", we obey a parameter in the consensus document\&. (Default: auto)
.RE
.SH "CLIENT OPTIONS"
.sp
The following options are useful only for clients (that is, if \fBSocksPort\fR, \fBTransPort\fR, \fBDNSPort\fR, or \fBNATDPort\fR is non\-zero):
.PP
\fBBridge\fR [\fItransport\fR] \fIIP\fR:\fIORPort\fR [\fIfingerprint\fR]
.RS 4
When set along with UseBridges, instructs Tor to use the relay at "IP:ORPort" as a "bridge" relaying into the Tor network\&. If "fingerprint" is provided (using the same format as for DirAuthority), we will verify that the relay running at that location has the right fingerprint\&. We also use fingerprint to look up the bridge descriptor at the bridge authority, if it\(cqs provided and if UpdateBridgesFromAuthority is set too\&.


If "transport" is provided, it must match a ClientTransportPlugin line\&. We then use that pluggable transport\(cqs proxy to transfer data to the bridge, rather than connecting to the bridge directly\&. Some transports use a transport\-specific method to work out the remote address to connect to\&. These transports typically ignore the "IP:ORPort" specified in the bridge line\&.


Tor passes any "key=val" settings to the pluggable transport proxy as per\-connection arguments when connecting to the bridge\&. Consult the documentation of the pluggable transport for details of what arguments it supports\&.
.RE
.PP
\fBLearnCircuitBuildTimeout\fR \fB0\fR|\fB1\fR
.RS 4
If 0, CircuitBuildTimeout adaptive learning is disabled\&. (Default: 1)
.RE
.PP
\fBCircuitBuildTimeout\fR \fINUM\fR
.RS 4
Try for at most NUM seconds when building circuits\&. If the circuit isn\(cqt open in that time, give up on it\&. If LearnCircuitBuildTimeout is 1, this value serves as the initial value to use before a timeout is learned\&. If LearnCircuitBuildTimeout is 0, this value is the only value used\&. (Default: 60 seconds)
.RE
.PP
\fBCircuitsAvailableTimeout\fR \fINUM\fR
.RS 4
Tor will attempt to keep at least one open, unused circuit available for this amount of time\&. This option governs how long idle circuits are kept open, as well as the amount of time Tor will keep a circuit open to each of the recently used ports\&. This way when the Tor client is entirely idle, it can expire all of its circuits, and then expire its TLS connections\&. Note that the actual timeout value is uniformly randomized from the specified value to twice that amount\&. (Default: 30 minutes; Max: 24 hours)
.RE
.PP
\fBCircuitStreamTimeout\fR \fINUM\fR
.RS 4
If non\-zero, this option overrides our internal timeout schedule for how many seconds until we detach a stream from a circuit and try a new circuit\&. If your network is particularly slow, you might want to set this to a number like 60\&. (Default: 0)
.RE
.PP
\fBClientOnly\fR \fB0\fR|\fB1\fR
.RS 4
If set to 1, Tor will not run as a relay or serve directory requests, even if the ORPort, ExtORPort, or DirPort options are set\&. (This config option is mostly unnecessary: we added it back when we were considering having Tor clients auto\-promote themselves to being relays if they were stable and fast enough\&. The current behavior is simply that Tor is a client unless ORPort, ExtORPort, or DirPort are configured\&.) (Default: 0)
.RE
.PP
\fBConnectionPadding\fR \fB0\fR|\fB1\fR|\fBauto\fR
.RS 4
This option governs Tor\(cqs use of padding to defend against some forms of traffic analysis\&. If it is set to
\fIauto\fR, Tor will send padding only if both the client and the relay support it\&. If it is set to 0, Tor will not send any padding cells\&. If it is set to 1, Tor will still send padding for client connections regardless of relay support\&. Only clients may set this option\&. This option should be offered via the UI to mobile users for use where bandwidth may be expensive\&. (Default: auto)
.RE
.PP
\fBReducedConnectionPadding\fR \fB0\fR|\fB1\fR
.RS 4
If set to 1, Tor will not not hold OR connections open for very long, and will send less padding on these connections\&. Only clients may set this option\&. This option should be offered via the UI to mobile users for use where bandwidth may be expensive\&. (Default: 0)
.RE
.PP
\fBExcludeNodes\fR \fInode\fR,\fInode\fR,\fI\&...\fR
.RS 4
A list of identity fingerprints, country codes, and address patterns of nodes to avoid when building a circuit\&. Country codes are 2\-letter ISO3166 codes, and must be wrapped in braces; fingerprints may be preceded by a dollar sign\&. (Example: ExcludeNodes ABCD1234CDEF5678ABCD1234CDEF5678ABCD1234, {cc}, 255\&.254\&.0\&.0/8)


By default, this option is treated as a preference that Tor is allowed to override in order to keep working\&. For example, if you try to connect to a hidden service, but you have excluded all of the hidden service\(cqs introduction points, Tor will connect to one of them anyway\&. If you do not want this behavior, set the StrictNodes option (documented below)\&.


Note also that if you are a relay, this (and the other node selection options below) only affects your own circuits that Tor builds for you\&. Clients can still build circuits through you to any node\&. Controllers can tell Tor to build circuits through any node\&.


Country codes are case\-insensitive\&. The code "{??}" refers to nodes whose country can\(cqt be identified\&. No country code, including {??}, works if no GeoIPFile can be loaded\&. See also the GeoIPExcludeUnknown option below\&.
.RE
.PP
\fBExcludeExitNodes\fR \fInode\fR,\fInode\fR,\fI\&...\fR
.RS 4
A list of identity fingerprints, country codes, and address patterns of nodes to never use when picking an exit node\-\-\-that is, a node that delivers traffic for you
\fBoutside\fR
the Tor network\&. Note that any node listed in ExcludeNodes is automatically considered to be part of this list too\&. See the
\fBExcludeNodes\fR
option for more information on how to specify nodes\&. See also the caveats on the "ExitNodes" option below\&.
.RE
.PP
\fBGeoIPExcludeUnknown\fR \fB0\fR|\fB1\fR|\fBauto\fR
.RS 4
If this option is set to
\fIauto\fR, then whenever any country code is set in ExcludeNodes or ExcludeExitNodes, all nodes with unknown country ({??} and possibly {A1}) are treated as excluded as well\&. If this option is set to
\fI1\fR, then all unknown countries are treated as excluded in ExcludeNodes and ExcludeExitNodes\&. This option has no effect when a GeoIP file isn\(cqt configured or can\(cqt be found\&. (Default: auto)
.RE
.PP
\fBExitNodes\fR \fInode\fR,\fInode\fR,\fI\&...\fR
.RS 4
A list of identity fingerprints, country codes, and address patterns of nodes to use as exit node\-\-\-that is, a node that delivers traffic for you
\fBoutside\fR
the Tor network\&. See the
\fBExcludeNodes\fR
option for more information on how to specify nodes\&.


Note that if you list too few nodes here, or if you exclude too many exit nodes with ExcludeExitNodes, you can degrade functionality\&. For example, if none of the exits you list allows traffic on port 80 or 443, you won\(cqt be able to browse the web\&.


Note also that not every circuit is used to deliver traffic
\fBoutside\fR
of the Tor network\&. It is normal to see non\-exit circuits (such as those used to connect to hidden services, those that do directory fetches, those used for relay reachability self\-tests, and so on) that end at a non\-exit node\&. To keep a node from being used entirely, see ExcludeNodes and StrictNodes\&.


The ExcludeNodes option overrides this option: any node listed in both ExitNodes and ExcludeNodes is treated as excluded\&.


The \&.exit address notation, if enabled via AllowDotExit, overrides this option\&.
.RE
.PP
\fBEntryNodes\fR \fInode\fR,\fInode\fR,\fI\&...\fR
.RS 4
A list of identity fingerprints and country codes of nodes to use for the first hop in your normal circuits\&. Normal circuits include all circuits except for direct connections to directory servers\&. The Bridge option overrides this option; if you have configured bridges and UseBridges is 1, the Bridges are used as your entry nodes\&.


The ExcludeNodes option overrides this option: any node listed in both EntryNodes and ExcludeNodes is treated as excluded\&. See the
\fBExcludeNodes\fR
option for more information on how to specify nodes\&.
.RE
.PP
\fBStrictNodes\fR \fB0\fR|\fB1\fR
.RS 4
If StrictNodes is set to 1, Tor will treat solely the ExcludeNodes option as a requirement to follow for all the circuits you generate, even if doing so will break functionality for you (StrictNodes applies to neither ExcludeExitNodes nor to ExitNodes)\&. If StrictNodes is set to 0, Tor will still try to avoid nodes in the ExcludeNodes list, but it will err on the side of avoiding unexpected errors\&. Specifically, StrictNodes 0 tells Tor that it is okay to use an excluded node when it is
\fBnecessary\fR
to perform relay reachability self\-tests, connect to a hidden service, provide a hidden service to a client, fulfill a \&.exit request, upload directory information, or download directory information\&. (Default: 0)
.RE
.PP
\fBFascistFirewall\fR \fB0\fR|\fB1\fR
.RS 4
If 1, Tor will only create outgoing connections to ORs running on ports that your firewall allows (defaults to 80 and 443; see
\fBFirewallPorts\fR)\&. This will allow you to run Tor as a client behind a firewall with restrictive policies, but will not allow you to run as a server behind such a firewall\&. If you prefer more fine\-grained control, use ReachableAddresses instead\&.
.RE
.PP
\fBFirewallPorts\fR \fIPORTS\fR
.RS 4
A list of ports that your firewall allows you to connect to\&. Only used when
\fBFascistFirewall\fR
is set\&. This option is deprecated; use ReachableAddresses instead\&. (Default: 80, 443)
.RE
.PP
\fBReachableAddresses\fR \fIADDR\fR[/\fIMASK\fR][:\fIPORT\fR]\&...
.RS 4
A comma\-separated list of IP addresses and ports that your firewall allows you to connect to\&. The format is as for the addresses in ExitPolicy, except that "accept" is understood unless "reject" is explicitly provided\&. For example, \*(AqReachableAddresses 99\&.0\&.0\&.0/8, reject 18\&.0\&.0\&.0/8:80, accept *:80\*(Aq means that your firewall allows connections to everything inside net 99, rejects port 80 connections to net 18, and accepts connections to port 80 otherwise\&. (Default: \*(Aqaccept *:*\*(Aq\&.)
.RE
.PP
\fBReachableDirAddresses\fR \fIADDR\fR[/\fIMASK\fR][:\fIPORT\fR]\&...
.RS 4
Like
\fBReachableAddresses\fR, a list of addresses and ports\&. Tor will obey these restrictions when fetching directory information, using standard HTTP GET requests\&. If not set explicitly then the value of
\fBReachableAddresses\fR
is used\&. If
\fBHTTPProxy\fR
is set then these connections will go through that proxy\&.
.RE
.PP
\fBReachableORAddresses\fR \fIADDR\fR[/\fIMASK\fR][:\fIPORT\fR]\&...
.RS 4
Like
\fBReachableAddresses\fR, a list of addresses and ports\&. Tor will obey these restrictions when connecting to Onion Routers, using TLS/SSL\&. If not set explicitly then the value of
\fBReachableAddresses\fR
is used\&. If
\fBHTTPSProxy\fR
is set then these connections will go through that proxy\&.


The separation between
\fBReachableORAddresses\fR
and
\fBReachableDirAddresses\fR
is only interesting when you are connecting through proxies (see
\fBHTTPProxy\fR
and
\fBHTTPSProxy\fR)\&. Most proxies limit TLS connections (which Tor uses to connect to Onion Routers) to port 443, and some limit HTTP GET requests (which Tor uses for fetching directory information) to port 80\&.
.RE
.PP
\fBHidServAuth\fR \fIonion\-address\fR \fIauth\-cookie\fR [\fIservice\-name\fR]
.RS 4
Client authorization for a hidden service\&. Valid onion addresses contain 16 characters in a\-z2\-7 plus "\&.onion", and valid auth cookies contain 22 characters in A\-Za\-z0\-9+/\&. The service name is only used for internal purposes, e\&.g\&., for Tor controllers\&. This option may be used multiple times for different hidden services\&. If a hidden service uses authorization and this option is not set, the hidden service is not accessible\&. Hidden services can be configured to require authorization using the
\fBHiddenServiceAuthorizeClient\fR
option\&.
.RE
.PP
\fBLongLivedPorts\fR \fIPORTS\fR
.RS 4
A list of ports for services that tend to have long\-running connections (e\&.g\&. chat and interactive shells)\&. Circuits for streams that use these ports will contain only high\-uptime nodes, to reduce the chance that a node will go down before the stream is finished\&. Note that the list is also honored for circuits (both client and service side) involving hidden services whose virtual port is in this list\&. (Default: 21, 22, 706, 1863, 5050, 5190, 5222, 5223, 6523, 6667, 6697, 8300)
.RE
.PP
\fBMapAddress\fR \fIaddress\fR \fInewaddress\fR
.RS 4
When a request for address arrives to Tor, it will transform to newaddress before processing it\&. For example, if you always want connections to www\&.example\&.com to exit via
\fItorserver\fR
(where
\fItorserver\fR
is the fingerprint of the server), use "MapAddress www\&.example\&.com www\&.example\&.com\&.torserver\&.exit"\&. If the value is prefixed with a "*\&.", matches an entire domain\&. For example, if you always want connections to example\&.com and any if its subdomains to exit via
\fItorserver\fR
(where
\fItorserver\fR
is the fingerprint of the server), use "MapAddress *\&.example\&.com *\&.example\&.com\&.torserver\&.exit"\&. (Note the leading "*\&." in each part of the directive\&.) You can also redirect all subdomains of a domain to a single address\&. For example, "MapAddress *\&.example\&.com www\&.example\&.com"\&.


NOTES:
.sp
.RS 4
.ie n \{\
\h'-04' 1.\h'+01'\c
.\}
.el \{\
.sp -1
.IP "  1." 4.2
.\}
When evaluating MapAddress expressions Tor stops when it hits the most recently added expression that matches the requested address\&. So if you have the following in your torrc, www\&.torproject\&.org will map to 1\&.1\&.1\&.1:
.sp
.if n \{\
.RS 4
.\}
.nf
MapAddress www\&.torproject\&.org 2\&.2\&.2\&.2
MapAddress www\&.torproject\&.org 1\&.1\&.1\&.1
.fi
.if n \{\
.RE
.\}
.RE
.sp
.RS 4
.ie n \{\
\h'-04' 2.\h'+01'\c
.\}
.el \{\
.sp -1
.IP "  2." 4.2
.\}
Tor evaluates the MapAddress configuration until it finds no matches\&. So if you have the following in your torrc, www\&.torproject\&.org will map to 2\&.2\&.2\&.2:
.sp
.if n \{\
.RS 4
.\}
.nf
MapAddress 1\&.1\&.1\&.1 2\&.2\&.2\&.2
MapAddress www\&.torproject\&.org 1\&.1\&.1\&.1
.fi
.if n \{\
.RE
.\}
.RE
.sp
.RS 4
.ie n \{\
\h'-04' 3.\h'+01'\c
.\}
.el \{\
.sp -1
.IP "  3." 4.2
.\}
The following MapAddress expression is invalid (and will be ignored) because you cannot map from a specific address to a wildcard address:
.sp
.if n \{\
.RS 4
.\}
.nf
MapAddress www\&.torproject\&.org *\&.torproject\&.org\&.torserver\&.exit
.fi
.if n \{\
.RE
.\}
.RE
.sp
.RS 4
.ie n \{\
\h'-04' 4.\h'+01'\c
.\}
.el \{\
.sp -1
.IP "  4." 4.2
.\}
Using a wildcard to match only part of a string (as in *ample\&.com) is also invalid\&.
.RE
.RE
.PP
\fBNewCircuitPeriod\fR \fINUM\fR
.RS 4
Every NUM seconds consider whether to build a new circuit\&. (Default: 30 seconds)
.RE
.PP
\fBMaxCircuitDirtiness\fR \fINUM\fR
.RS 4
Feel free to reuse a circuit that was first used at most NUM seconds ago, but never attach a new stream to a circuit that is too old\&. For hidden services, this applies to the
\fIlast\fR
time a circuit was used, not the first\&. Circuits with streams constructed with SOCKS authentication via SocksPorts that have
\fBKeepAliveIsolateSOCKSAuth\fR
also remain alive for MaxCircuitDirtiness seconds after carrying the last such stream\&. (Default: 10 minutes)
.RE
.PP
\fBMaxClientCircuitsPending\fR \fINUM\fR
.RS 4
Do not allow more than NUM circuits to be pending at a time for handling client streams\&. A circuit is pending if we have begun constructing it, but it has not yet been completely constructed\&. (Default: 32)
.RE
.PP
\fBNodeFamily\fR \fInode\fR,\fInode\fR,\fI\&...\fR
.RS 4
The Tor servers, defined by their identity fingerprints, constitute a "family" of similar or co\-administered servers, so never use any two of them in the same circuit\&. Defining a NodeFamily is only needed when a server doesn\(cqt list the family itself (with MyFamily)\&. This option can be used multiple times; each instance defines a separate family\&. In addition to nodes, you can also list IP address and ranges and country codes in {curly braces}\&. See the
\fBExcludeNodes\fR
option for more information on how to specify nodes\&.
.RE
.PP
\fBEnforceDistinctSubnets\fR \fB0\fR|\fB1\fR
.RS 4
If 1, Tor will not put two servers whose IP addresses are "too close" on the same circuit\&. Currently, two addresses are "too close" if they lie in the same /16 range\&. (Default: 1)
.RE
.PP
\fBSocksPort\fR [\fIaddress\fR:]\fIport\fR|\fBunix:\fR\fIpath\fR|\fBauto\fR [\fIflags\fR] [\fIisolation flags\fR]
.RS 4
Open this port to listen for connections from SOCKS\-speaking applications\&. Set this to 0 if you don\(cqt want to allow application connections via SOCKS\&. Set it to "auto" to have Tor pick a port for you\&. This directive can be specified multiple times to bind to multiple addresses/ports\&. If a unix domain socket is used, you may quote the path using standard C escape sequences\&. (Default: 9050)


NOTE: Although this option allows you to specify an IP address other than localhost, you should do so only with extreme caution\&. The SOCKS protocol is unencrypted and (as we use it) unauthenticated, so exposing it in this way could leak your information to anybody watching your network, and allow anybody to use your computer as an open proxy\&.


The
\fIisolation flags\fR
arguments give Tor rules for which streams received on this SocksPort are allowed to share circuits with one another\&. Recognized isolation flags are:
.PP
\fBIsolateClientAddr\fR
.RS 4
Don\(cqt share circuits with streams from a different client address\&. (On by default and strongly recommended when supported; you can disable it with
\fBNoIsolateClientAddr\fR\&. Unsupported and force\-disabled when using Unix domain sockets\&.)
.RE
.PP
\fBIsolateSOCKSAuth\fR
.RS 4
Don\(cqt share circuits with streams for which different SOCKS authentication was provided\&. (On by default; you can disable it with
\fBNoIsolateSOCKSAuth\fR\&.)
.RE
.PP
\fBIsolateClientProtocol\fR
.RS 4
Don\(cqt share circuits with streams using a different protocol\&. (SOCKS 4, SOCKS 5, TransPort connections, NATDPort connections, and DNSPort requests are all considered to be different protocols\&.)
.RE
.PP
\fBIsolateDestPort\fR
.RS 4
Don\(cqt share circuits with streams targeting a different destination port\&.
.RE
.PP
\fBIsolateDestAddr\fR
.RS 4
Don\(cqt share circuits with streams targeting a different destination address\&.
.RE
.PP
\fBKeepAliveIsolateSOCKSAuth\fR
.RS 4
If
\fBIsolateSOCKSAuth\fR
is enabled, keep alive circuits while they have at least one stream with SOCKS authentication active\&. After such a circuit is idle for more than MaxCircuitDirtiness seconds, it can be closed\&.
.RE
.PP
\fBSessionGroup=\fR\fIINT\fR
.RS 4
If no other isolation rules would prevent it, allow streams on this port to share circuits with streams from every other port with the same session group\&. (By default, streams received on different SocksPorts, TransPorts, etc are always isolated from one another\&. This option overrides that behavior\&.)
.RE
.RE
.PP
.RS 4
Other recognized
\fIflags\fR
for a SocksPort are:
.PP
\fBNoIPv4Traffic\fR
.RS 4
Tell exits to not connect to IPv4 addresses in response to SOCKS requests on this connection\&.
.RE
.PP
\fBIPv6Traffic\fR
.RS 4
Tell exits to allow IPv6 addresses in response to SOCKS requests on this connection, so long as SOCKS5 is in use\&. (SOCKS4 can\(cqt handle IPv6\&.)
.RE
.PP
\fBPreferIPv6\fR
.RS 4
Tells exits that, if a host has both an IPv4 and an IPv6 address, we would prefer to connect to it via IPv6\&. (IPv4 is the default\&.)
.RE
.PP
\fBNoDNSRequest\fR
.RS 4
Do not ask exits to resolve DNS addresses in SOCKS5 requests\&. Tor will connect to IPv4 addresses, IPv6 addresses (if IPv6Traffic is set) and \&.onion addresses\&.
.RE
.PP
\fBNoOnionTraffic\fR
.RS 4
Do not connect to \&.onion addresses in SOCKS5 requests\&.
.RE
.PP
\fBOnionTrafficOnly\fR
.RS 4
Tell the tor client to only connect to \&.onion addresses in response to SOCKS5 requests on this connection\&. This is equivalent to NoDNSRequest, NoIPv4Traffic, NoIPv6Traffic\&. The corresponding NoOnionTrafficOnly flag is not supported\&.
.RE
.PP
\fBCacheIPv4DNS\fR
.RS 4
Tells the client to remember IPv4 DNS answers we receive from exit nodes via this connection\&. (On by default\&.)
.RE
.PP
\fBCacheIPv6DNS\fR
.RS 4
Tells the client to remember IPv6 DNS answers we receive from exit nodes via this connection\&.
.RE
.PP
\fBGroupWritable\fR
.RS 4
Unix domain sockets only: makes the socket get created as group\-writable\&.
.RE
.PP
\fBWorldWritable\fR
.RS 4
Unix domain sockets only: makes the socket get created as world\-writable\&.
.RE
.PP
\fBCacheDNS\fR
.RS 4
Tells the client to remember all DNS answers we receive from exit nodes via this connection\&.
.RE
.PP
\fBUseIPv4Cache\fR
.RS 4
Tells the client to use any cached IPv4 DNS answers we have when making requests via this connection\&. (NOTE: This option, along UseIPv6Cache and UseDNSCache, can harm your anonymity, and probably won\(cqt help performance as much as you might expect\&. Use with care!)
.RE
.PP
\fBUseIPv6Cache\fR
.RS 4
Tells the client to use any cached IPv6 DNS answers we have when making requests via this connection\&.
.RE
.PP
\fBUseDNSCache\fR
.RS 4
Tells the client to use any cached DNS answers we have when making requests via this connection\&.
.RE
.PP
\fBPreferIPv6Automap\fR
.RS 4
When serving a hostname lookup request on this port that should get automapped (according to AutomapHostsOnResolve), if we could return either an IPv4 or an IPv6 answer, prefer an IPv6 answer\&. (On by default\&.)
.RE
.PP
\fBPreferSOCKSNoAuth\fR
.RS 4
Ordinarily, when an application offers both "username/password authentication" and "no authentication" to Tor via SOCKS5, Tor selects username/password authentication so that IsolateSOCKSAuth can work\&. This can confuse some applications, if they offer a username/password combination then get confused when asked for one\&. You can disable this behavior, so that Tor will select "No authentication" when IsolateSOCKSAuth is disabled, or when this option is set\&.
.RE
.RE
.PP
.RS 4
Flags are processed left to right\&. If flags conflict, the last flag on the line is used, and all earlier flags are ignored\&. No error is issued for conflicting flags\&.
.RE
.PP
\fBSocksPolicy\fR \fIpolicy\fR,\fIpolicy\fR,\fI\&...\fR
.RS 4
Set an entrance policy for this server, to limit who can connect to the SocksPort and DNSPort ports\&. The policies have the same form as exit policies below, except that port specifiers are ignored\&. Any address not matched by some entry in the policy is accepted\&.
.RE
.PP
\fBSocksTimeout\fR \fINUM\fR
.RS 4
Let a socks connection wait NUM seconds handshaking, and NUM seconds unattached waiting for an appropriate circuit, before we fail it\&. (Default: 2 minutes)
.RE
.PP
\fBTokenBucketRefillInterval\fR \fINUM\fR [\fBmsec\fR|\fBsecond\fR]
.RS 4
Set the refill interval of Tor\(cqs token bucket to NUM milliseconds\&. NUM must be between 1 and 1000, inclusive\&. Note that the configured bandwidth limits are still expressed in bytes per second: this option only affects the frequency with which Tor checks to see whether previously exhausted connections may read again\&. Can not be changed while tor is running\&. (Default: 100 msec)
.RE
.PP
\fBTrackHostExits\fR \fIhost\fR,\fI\&.domain\fR,\fI\&...\fR
.RS 4
For each value in the comma separated list, Tor will track recent connections to hosts that match this value and attempt to reuse the same exit node for each\&. If the value is prepended with a \*(Aq\&.\*(Aq, it is treated as matching an entire domain\&. If one of the values is just a \*(Aq\&.\*(Aq, it means match everything\&. This option is useful if you frequently connect to sites that will expire all your authentication cookies (i\&.e\&. log you out) if your IP address changes\&. Note that this option does have the disadvantage of making it more clear that a given history is associated with a single user\&. However, most people who would wish to observe this will observe it through cookies or other protocol\-specific means anyhow\&.
.RE
.PP
\fBTrackHostExitsExpire\fR \fINUM\fR
.RS 4
Since exit servers go up and down, it is desirable to expire the association between host and exit server after NUM seconds\&. The default is 1800 seconds (30 minutes)\&.
.RE
.PP
\fBUpdateBridgesFromAuthority\fR \fB0\fR|\fB1\fR
.RS 4
When set (along with UseBridges), Tor will try to fetch bridge descriptors from the configured bridge authorities when feasible\&. It will fall back to a direct request if the authority responds with a 404\&. (Default: 0)
.RE
.PP
\fBUseBridges\fR \fB0\fR|\fB1\fR
.RS 4
When set, Tor will fetch descriptors for each bridge listed in the "Bridge" config lines, and use these relays as both entry guards and directory guards\&. (Default: 0)
.RE
.PP
\fBUseEntryGuards\fR \fB0\fR|\fB1\fR
.RS 4
If this option is set to 1, we pick a few long\-term entry servers, and try to stick with them\&. This is desirable because constantly changing servers increases the odds that an adversary who owns some servers will observe a fraction of your paths\&. Entry Guards can not be used by Directory Authorities, Single Onion Services, and Tor2web clients\&. In these cases, the this option is ignored\&. (Default: 1)
.RE
.PP
\fBGuardfractionFile\fR \fIFILENAME\fR
.RS 4
V3 authoritative directories only\&. Configures the location of the guardfraction file which contains information about how long relays have been guards\&. (Default: unset)
.RE
.PP
\fBUseGuardFraction\fR \fB0\fR|\fB1\fR|\fBauto\fR
.RS 4
This torrc option specifies whether clients should use the guardfraction information found in the consensus during path selection\&. If it\(cqs set to
\fIauto\fR, clients will do what the UseGuardFraction consensus parameter tells them to do\&. (Default: auto)
.RE
.PP
\fBNumEntryGuards\fR \fINUM\fR
.RS 4
If UseEntryGuards is set to 1, we will try to pick a total of NUM routers as long\-term entries for our circuits\&. If NUM is 0, we try to learn the number from the guard\-n\-primary\-guards\-to\-use consensus parameter, and default to 1 if the consensus parameter isn\(cqt set\&. (Default: 0)
.RE
.PP
\fBNumDirectoryGuards\fR \fINUM\fR
.RS 4
If UseEntryGuardsAsDirectoryGuards is enabled, we try to make sure we have at least NUM routers to use as directory guards\&. If this option is set to 0, use the value from the guard\-n\-primary\-dir\-guards\-to\-use consensus parameter, and default to 3 if the consensus parameter isn\(cqt set\&. (Default: 0)
.RE
.PP
\fBGuardLifetime\fR \fIN\fR \fBdays\fR|\fBweeks\fR|\fBmonths\fR
.RS 4
If nonzero, and UseEntryGuards is set, minimum time to keep a guard before picking a new one\&. If zero, we use the GuardLifetime parameter from the consensus directory\&. No value here may be less than 1 month or greater than 5 years; out\-of\-range values are clamped\&. (Default: 0)
.RE
.PP
\fBSafeSocks\fR \fB0\fR|\fB1\fR
.RS 4
When this option is enabled, Tor will reject application connections that use unsafe variants of the socks protocol \(em ones that only provide an IP address, meaning the application is doing a DNS resolve first\&. Specifically, these are socks4 and socks5 when not doing remote DNS\&. (Default: 0)
.RE
.PP
\fBTestSocks\fR \fB0\fR|\fB1\fR
.RS 4
When this option is enabled, Tor will make a notice\-level log entry for each connection to the Socks port indicating whether the request used a safe socks protocol or an unsafe one (see above entry on SafeSocks)\&. This helps to determine whether an application using Tor is possibly leaking DNS requests\&. (Default: 0)
.RE
.sp
\fBVirtualAddrNetworkIPv4\fR \fIAddress\fR/\fIbits\fR
.PP
\fBVirtualAddrNetworkIPv6\fR [\fIAddress\fR]/\fIbits\fR
.RS 4
When Tor needs to assign a virtual (unused) address because of a MAPADDRESS command from the controller or the AutomapHostsOnResolve feature, Tor picks an unassigned address from this range\&. (Defaults: 127\&.192\&.0\&.0/10 and [FE80::]/10 respectively\&.)


When providing proxy server service to a network of computers using a tool like dns\-proxy\-tor, change the IPv4 network to "10\&.192\&.0\&.0/10" or "172\&.16\&.0\&.0/12" and change the IPv6 network to "[FC00::]/7"\&. The default
\fBVirtualAddrNetwork\fR
address ranges on a properly configured machine will route to the loopback or link\-local interface\&. The maximum number of bits for the network prefix is set to 104 for IPv6 and 16 for IPv4\&. However, a wider network \- smaller prefix length
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
is preferable since it reduces the chances for an attacker to guess the used IP\&. For local use, no change to the default VirtualAddrNetwork setting is needed\&.
.RE
.RE
.PP
\fBAllowNonRFC953Hostnames\fR \fB0\fR|\fB1\fR
.RS 4
When this option is disabled, Tor blocks hostnames containing illegal characters (like @ and :) rather than sending them to an exit node to be resolved\&. This helps trap accidental attempts to resolve URLs and so on\&. (Default: 0)
.RE
.PP
\fBAllowDotExit\fR \fB0\fR|\fB1\fR
.RS 4
If enabled, we convert "www\&.google\&.com\&.foo\&.exit" addresses on the SocksPort/TransPort/NATDPort into "www\&.google\&.com" addresses that exit from the node "foo"\&. Disabled by default since attacking websites and exit relays can use it to manipulate your path selection\&. (Default: 0)
.RE
.PP
\fBTransPort\fR [\fIaddress\fR:]\fIport\fR|\fBauto\fR [\fIisolation flags\fR]
.RS 4
Open this port to listen for transparent proxy connections\&. Set this to 0 if you don\(cqt want to allow transparent proxy connections\&. Set the port to "auto" to have Tor pick a port for you\&. This directive can be specified multiple times to bind to multiple addresses/ports\&. See SOCKSPort for an explanation of isolation flags\&.


TransPort requires OS support for transparent proxies, such as BSDs\*(Aq pf or Linux\(cqs IPTables\&. If you\(cqre planning to use Tor as a transparent proxy for a network, you\(cqll want to examine and change VirtualAddrNetwork from the default setting\&. (Default: 0)
.RE
.PP
\fBTransProxyType\fR \fBdefault\fR|\fBTPROXY\fR|\fBipfw\fR|\fBpf\-divert\fR
.RS 4
TransProxyType may only be enabled when there is transparent proxy listener enabled\&.


Set this to "TPROXY" if you wish to be able to use the TPROXY Linux module to transparently proxy connections that are configured using the TransPort option\&. Detailed information on how to configure the TPROXY feature can be found in the Linux kernel source tree in the file Documentation/networking/tproxy\&.txt\&.


Set this option to "ipfw" to use the FreeBSD ipfw interface\&.


On *BSD operating systems when using pf, set this to "pf\-divert" to take advantage of
divert\-to
rules, which do not modify the packets like
rdr\-to
rules do\&. Detailed information on how to configure pf to use
divert\-to
rules can be found in the pf\&.conf(5) manual page\&. On OpenBSD,
divert\-to
is available to use on versions greater than or equal to OpenBSD 4\&.4\&.


Set this to "default", or leave it unconfigured, to use regular IPTables on Linux, or to use pf
rdr\-to
rules on *BSD systems\&.


(Default: "default"\&.)
.RE
.PP
\fBNATDPort\fR [\fIaddress\fR:]\fIport\fR|\fBauto\fR [\fIisolation flags\fR]
.RS 4
Open this port to listen for connections from old versions of ipfw (as included in old versions of FreeBSD, etc) using the NATD protocol\&. Use 0 if you don\(cqt want to allow NATD connections\&. Set the port to "auto" to have Tor pick a port for you\&. This directive can be specified multiple times to bind to multiple addresses/ports\&. See SocksPort for an explanation of isolation flags\&.


This option is only for people who cannot use TransPort\&. (Default: 0)
.RE
.PP
\fBAutomapHostsOnResolve\fR \fB0\fR|\fB1\fR
.RS 4
When this option is enabled, and we get a request to resolve an address that ends with one of the suffixes in
\fBAutomapHostsSuffixes\fR, we map an unused virtual address to that address, and return the new virtual address\&. This is handy for making "\&.onion" addresses work with applications that resolve an address and then connect to it\&. (Default: 0)
.RE
.PP
\fBAutomapHostsSuffixes\fR \fISUFFIX\fR,\fISUFFIX\fR,\fI\&...\fR
.RS 4
A comma\-separated list of suffixes to use with
\fBAutomapHostsOnResolve\fR\&. The "\&." suffix is equivalent to "all addresses\&." (Default: \&.exit,\&.onion)\&.
.RE
.PP
\fBDNSPort\fR [\fIaddress\fR:]\fIport\fR|\fBauto\fR [\fIisolation flags\fR]
.RS 4
If non\-zero, open this port to listen for UDP DNS requests, and resolve them anonymously\&. This port only handles A, AAAA, and PTR requests\-\-\-it doesn\(cqt handle arbitrary DNS request types\&. Set the port to "auto" to have Tor pick a port for you\&. This directive can be specified multiple times to bind to multiple addresses/ports\&. See SocksPort for an explanation of isolation flags\&. (Default: 0)
.RE
.PP
\fBClientDNSRejectInternalAddresses\fR \fB0\fR|\fB1\fR
.RS 4
If true, Tor does not believe any anonymously retrieved DNS answer that tells it that an address resolves to an internal address (like 127\&.0\&.0\&.1 or 192\&.168\&.0\&.1)\&. This option prevents certain browser\-based attacks; don\(cqt turn it off unless you know what you\(cqre doing\&. (Default: 1)
.RE
.PP
\fBClientRejectInternalAddresses\fR \fB0\fR|\fB1\fR
.RS 4
If true, Tor does not try to fulfill requests to connect to an internal address (like 127\&.0\&.0\&.1 or 192\&.168\&.0\&.1)
\fIunless a exit node is specifically requested\fR
(for example, via a \&.exit hostname, or a controller request)\&. If true, multicast DNS hostnames for machines on the local network (of the form *\&.local) are also rejected\&. (Default: 1)
.RE
.PP
\fBDownloadExtraInfo\fR \fB0\fR|\fB1\fR
.RS 4
If true, Tor downloads and caches "extra\-info" documents\&. These documents contain information about servers other than the information in their regular server descriptors\&. Tor does not use this information for anything itself; to save bandwidth, leave this option turned off\&. (Default: 0)
.RE
.PP
\fBWarnPlaintextPorts\fR \fIport\fR,\fIport\fR,\fI\&...\fR
.RS 4
Tells Tor to issue a warnings whenever the user tries to make an anonymous connection to one of these ports\&. This option is designed to alert users to services that risk sending passwords in the clear\&. (Default: 23,109,110,143)
.RE
.PP
\fBRejectPlaintextPorts\fR \fIport\fR,\fIport\fR,\fI\&...\fR
.RS 4
Like WarnPlaintextPorts, but instead of warning about risky port uses, Tor will instead refuse to make the connection\&. (Default: None)
.RE
.PP
\fBOptimisticData\fR \fB0\fR|\fB1\fR|\fBauto\fR
.RS 4
When this option is set, and Tor is using an exit node that supports the feature, it will try optimistically to send data to the exit node without waiting for the exit node to report whether the connection succeeded\&. This can save a round\-trip time for protocols like HTTP where the client talks first\&. If OptimisticData is set to
\fBauto\fR, Tor will look at the UseOptimisticData parameter in the networkstatus\&. (Default: auto)
.RE
.PP
\fBTor2webMode\fR \fB0\fR|\fB1\fR
.RS 4
When this option is set, Tor connects to hidden services
\fBnon\-anonymously\fR\&. This option also disables client connections to non\-hidden\-service hostnames through Tor\&. It
\fBmust only\fR
be used when running a tor2web Hidden Service web proxy\&. To enable this option the compile time flag \-\-enable\-tor2web\-mode must be specified\&. Since Tor2webMode is non\-anonymous, you can not run an anonymous Hidden Service on a tor version compiled with Tor2webMode\&. (Default: 0)
.RE
.PP
\fBTor2webRendezvousPoints\fR \fInode\fR,\fInode\fR,\fI\&...\fR
.RS 4
A list of identity fingerprints, nicknames, country codes and address patterns of nodes that are allowed to be used as RPs in HS circuits; any other nodes will not be used as RPs\&. (Example: Tor2webRendezvousPoints Fastyfasty, ABCD1234CDEF5678ABCD1234CDEF5678ABCD1234, {cc}, 255\&.254\&.0\&.0/8)


This feature can only be used if Tor2webMode is also enabled\&.


ExcludeNodes have higher priority than Tor2webRendezvousPoints, which means that nodes specified in ExcludeNodes will not be picked as RPs\&.


If no nodes in Tor2webRendezvousPoints are currently available for use, Tor will choose a random node when building HS circuits\&.
.RE
.PP
\fBUseMicrodescriptors\fR \fB0\fR|\fB1\fR|\fBauto\fR
.RS 4
Microdescriptors are a smaller version of the information that Tor needs in order to build its circuits\&. Using microdescriptors makes Tor clients download less directory information, thus saving bandwidth\&. Directory caches need to fetch regular descriptors and microdescriptors, so this option doesn\(cqt save any bandwidth for them\&. If this option is set to "auto" (recommended) then it is on for all clients that do not set FetchUselessDescriptors\&. (Default: auto)
.RE
.sp
\fBPathBiasCircThreshold\fR \fINUM\fR
.sp
\fBPathBiasNoticeRate\fR \fINUM\fR
.sp
\fBPathBiasWarnRate\fR \fINUM\fR
.sp
\fBPathBiasExtremeRate\fR \fINUM\fR
.sp
\fBPathBiasDropGuards\fR \fINUM\fR
.PP
\fBPathBiasScaleThreshold\fR \fINUM\fR
.RS 4
These options override the default behavior of Tor\(cqs (\fBcurrently experimental\fR) path bias detection algorithm\&. To try to find broken or misbehaving guard nodes, Tor looks for nodes where more than a certain fraction of circuits through that guard fail to get built\&.


The PathBiasCircThreshold option controls how many circuits we need to build through a guard before we make these checks\&. The PathBiasNoticeRate, PathBiasWarnRate and PathBiasExtremeRate options control what fraction of circuits must succeed through a guard so we won\(cqt write log messages\&. If less than PathBiasExtremeRate circuits succeed
\fBand\fR
PathBiasDropGuards is set to 1, we disable use of that guard\&.


When we have seen more than PathBiasScaleThreshold circuits through a guard, we scale our observations by 0\&.5 (governed by the consensus) so that new observations don\(cqt get swamped by old ones\&.


By default, or if a negative value is provided for one of these options, Tor uses reasonable defaults from the networkstatus consensus document\&. If no defaults are available there, these options default to 150, \&.70, \&.50, \&.30, 0, and 300 respectively\&.
.RE
.sp
\fBPathBiasUseThreshold\fR \fINUM\fR
.sp
\fBPathBiasNoticeUseRate\fR \fINUM\fR
.sp
\fBPathBiasExtremeUseRate\fR \fINUM\fR
.PP
\fBPathBiasScaleUseThreshold\fR \fINUM\fR
.RS 4
Similar to the above options, these options override the default behavior of Tor\(cqs (\fBcurrently experimental\fR) path use bias detection algorithm\&.


Where as the path bias parameters govern thresholds for successfully building circuits, these four path use bias parameters govern thresholds only for circuit usage\&. Circuits which receive no stream usage are not counted by this detection algorithm\&. A used circuit is considered successful if it is capable of carrying streams or otherwise receiving well\-formed responses to RELAY cells\&.


By default, or if a negative value is provided for one of these options, Tor uses reasonable defaults from the networkstatus consensus document\&. If no defaults are available there, these options default to 20, \&.80, \&.60, and 100, respectively\&.
.RE
.PP
\fBClientUseIPv4\fR \fB0\fR|\fB1\fR
.RS 4
If this option is set to 0, Tor will avoid connecting to directory servers and entry nodes over IPv4\&. Note that clients with an IPv4 address in a
\fBBridge\fR, proxy, or pluggable transport line will try connecting over IPv4 even if
\fBClientUseIPv4\fR
is set to 0\&. (Default: 1)
.RE
.PP
\fBClientUseIPv6\fR \fB0\fR|\fB1\fR
.RS 4
If this option is set to 1, Tor might connect to directory servers or entry nodes over IPv6\&. Note that clients configured with an IPv6 address in a
\fBBridge\fR, proxy, or pluggable transport line will try connecting over IPv6 even if
\fBClientUseIPv6\fR
is set to 0\&. (Default: 0)
.RE
.PP
\fBClientPreferIPv6DirPort\fR \fB0\fR|\fB1\fR|\fBauto\fR
.RS 4
If this option is set to 1, Tor prefers a directory port with an IPv6 address over one with IPv4, for direct connections, if a given directory server has both\&. (Tor also prefers an IPv6 DirPort if IPv4Client is set to 0\&.) If this option is set to auto, clients prefer IPv4\&. Other things may influence the choice\&. This option breaks a tie to the favor of IPv6\&. (Default: auto)
.RE
.PP
\fBClientPreferIPv6ORPort\fR \fB0\fR|\fB1\fR|\fBauto\fR
.RS 4
If this option is set to 1, Tor prefers an OR port with an IPv6 address over one with IPv4 if a given entry node has both\&. (Tor also prefers an IPv6 ORPort if IPv4Client is set to 0\&.) If this option is set to auto, Tor bridge clients prefer the configured bridge address, and other clients prefer IPv4\&. Other things may influence the choice\&. This option breaks a tie to the favor of IPv6\&. (Default: auto)
.RE
.PP
\fBPathsNeededToBuildCircuits\fR \fINUM\fR
.RS 4
Tor clients don\(cqt build circuits for user traffic until they know about enough of the network so that they could potentially construct enough of the possible paths through the network\&. If this option is set to a fraction between 0\&.25 and 0\&.95, Tor won\(cqt build circuits until it has enough descriptors or microdescriptors to construct that fraction of possible paths\&. Note that setting this option too low can make your Tor client less anonymous, and setting it too high can prevent your Tor client from bootstrapping\&. If this option is negative, Tor will use a default value chosen by the directory authorities\&. If the directory authorities do not choose a value, Tor will default to 0\&.6\&. (Default: \-1\&.)
.RE
.PP
\fBClientBootstrapConsensusAuthorityDownloadSchedule\fR \fIN\fR,\fIN\fR,\fI\&...\fR
.RS 4
Schedule for when clients should download consensuses from authorities if they are bootstrapping (that is, they don\(cqt have a usable, reasonably live consensus)\&. Only used by clients fetching from a list of fallback directory mirrors\&. This schedule is advanced by (potentially concurrent) connection attempts, unlike other schedules, which are advanced by connection failures\&. (Default: 10, 11, 3600, 10800, 25200, 54000, 111600, 262800)
.RE
.PP
\fBClientBootstrapConsensusFallbackDownloadSchedule\fR \fIN\fR,\fIN\fR,\fI\&...\fR
.RS 4
Schedule for when clients should download consensuses from fallback directory mirrors if they are bootstrapping (that is, they don\(cqt have a usable, reasonably live consensus)\&. Only used by clients fetching from a list of fallback directory mirrors\&. This schedule is advanced by (potentially concurrent) connection attempts, unlike other schedules, which are advanced by connection failures\&. (Default: 0, 1, 4, 11, 3600, 10800, 25200, 54000, 111600, 262800)
.RE
.PP
\fBClientBootstrapConsensusAuthorityOnlyDownloadSchedule\fR \fIN\fR,\fIN\fR,\fI\&...\fR
.RS 4
Schedule for when clients should download consensuses from authorities if they are bootstrapping (that is, they don\(cqt have a usable, reasonably live consensus)\&. Only used by clients which don\(cqt have or won\(cqt fetch from a list of fallback directory mirrors\&. This schedule is advanced by (potentially concurrent) connection attempts, unlike other schedules, which are advanced by connection failures\&. (Default: 0, 3, 7, 3600, 10800, 25200, 54000, 111600, 262800)
.RE
.PP
\fBClientBootstrapConsensusMaxDownloadTries\fR \fINUM\fR
.RS 4
Try this many times to download a consensus while bootstrapping using fallback directory mirrors before giving up\&. (Default: 7)
.RE
.PP
\fBClientBootstrapConsensusAuthorityOnlyMaxDownloadTries\fR \fINUM\fR
.RS 4
Try this many times to download a consensus while bootstrapping using authorities before giving up\&. (Default: 4)
.RE
.PP
\fBClientBootstrapConsensusMaxInProgressTries\fR \fINUM\fR
.RS 4
Try this many simultaneous connections to download a consensus before waiting for one to complete, timeout, or error out\&. (Default: 4)
.RE
.SH "SERVER OPTIONS"
.sp
The following options are useful only for servers (that is, if ORPort is non\-zero):
.PP
\fBAddress\fR \fIaddress\fR
.RS 4
The IP address or fully qualified domain name of this server (e\&.g\&. moria\&.mit\&.edu)\&. You can leave this unset, and Tor will guess your IP address\&. This IP address is the one used to tell clients and other servers where to find your Tor server; it doesn\(cqt affect the IP that your Tor client binds to\&. To bind to a different address, use the *ListenAddress and OutboundBindAddress options\&.
.RE
.PP
\fBAssumeReachable\fR \fB0\fR|\fB1\fR
.RS 4
This option is used when bootstrapping a new Tor network\&. If set to 1, don\(cqt do self\-reachability testing; just upload your server descriptor immediately\&. If
\fBAuthoritativeDirectory\fR
is also set, this option instructs the dirserver to bypass remote reachability testing too and list all connected servers as running\&.
.RE
.PP
\fBBridgeRelay\fR \fB0\fR|\fB1\fR
.RS 4
Sets the relay to act as a "bridge" with respect to relaying connections from bridge users to the Tor network\&. It mainly causes Tor to publish a server descriptor to the bridge database, rather than to the public directory authorities\&.
.RE
.PP
\fBContactInfo\fR \fIemail_address\fR
.RS 4
Administrative contact information for this relay or bridge\&. This line can be used to contact you if your relay or bridge is misconfigured or something else goes wrong\&. Note that we archive and publish all descriptors containing these lines and that Google indexes them, so spammers might also collect them\&. You may want to obscure the fact that it\(cqs an email address and/or generate a new address for this purpose\&.
.RE
.PP
\fBExitRelay\fR \fB0\fR|\fB1\fR|\fBauto\fR
.RS 4
Tells Tor whether to run as an exit relay\&. If Tor is running as a non\-bridge server, and ExitRelay is set to 1, then Tor allows traffic to exit according to the ExitPolicy option (or the default ExitPolicy if none is specified)\&.


If ExitRelay is set to 0, no traffic is allowed to exit, and the ExitPolicy option is ignored\&.


If ExitRelay is set to "auto", then Tor behaves as if it were set to 1, but warns the user if this would cause traffic to exit\&. In a future version, the default value will be 0\&. (Default: auto)
.RE
.PP
\fBExitPolicy\fR \fIpolicy\fR,\fIpolicy\fR,\fI\&...\fR
.RS 4
Set an exit policy for this server\&. Each policy is of the form "\fBaccept[6]\fR|\fBreject[6]\fR
\fIADDR\fR[/\fIMASK\fR][:\fIPORT\fR]"\&. If /\fIMASK\fR
is omitted then this policy just applies to the host given\&. Instead of giving a host or network you can also use "*" to denote the universe (0\&.0\&.0\&.0/0 and ::/128), or *4 to denote all IPv4 addresses, and *6 to denote all IPv6 addresses\&.
\fIPORT\fR
can be a single port number, an interval of ports "\fIFROM_PORT\fR\-\fITO_PORT\fR", or "*"\&. If
\fIPORT\fR
is omitted, that means "*"\&.


For example, "accept 18\&.7\&.22\&.69:*,reject 18\&.0\&.0\&.0/8:*,accept *:*" would reject any IPv4 traffic destined for MIT except for web\&.mit\&.edu, and accept any other IPv4 or IPv6 traffic\&.


Tor also allows IPv6 exit policy entries\&. For instance, "reject6 [FC00::]/7:*" rejects all destinations that share 7 most significant bit prefix with address FC00::\&. Respectively, "accept6 [C000::]/3:*" accepts all destinations that share 3 most significant bit prefix with address C000::\&.


accept6 and reject6 only produce IPv6 exit policy entries\&. Using an IPv4 address with accept6 or reject6 is ignored and generates a warning\&. accept/reject allows either IPv4 or IPv6 addresses\&. Use *4 as an IPv4 wildcard address, and *6 as an IPv6 wildcard address\&. accept/reject * expands to matching IPv4 and IPv6 wildcard address rules\&.


To specify all IPv4 and IPv6 internal and link\-local networks (including 0\&.0\&.0\&.0/8, 169\&.254\&.0\&.0/16, 127\&.0\&.0\&.0/8, 192\&.168\&.0\&.0/16, 10\&.0\&.0\&.0/8, 172\&.16\&.0\&.0/12, [::]/8, [FC00::]/7, [FE80::]/10, [FEC0::]/10, [FF00::]/8, and [::]/127), you can use the "private" alias instead of an address\&. ("private" always produces rules for IPv4 and IPv6 addresses, even when used with accept6/reject6\&.)


Private addresses are rejected by default (at the beginning of your exit policy), along with any configured primary public IPv4 and IPv6 addresses\&. These private addresses are rejected unless you set the ExitPolicyRejectPrivate config option to 0\&. For example, once you\(cqve done that, you could allow HTTP to 127\&.0\&.0\&.1 and block all other connections to internal networks with "accept 127\&.0\&.0\&.1:80,reject private:*", though that may also allow connections to your own computer that are addressed to its public (external) IP address\&. See RFC 1918 and RFC 3330 for more details about internal and reserved IP address space\&. See ExitPolicyRejectLocalInterfaces if you want to block every address on the relay, even those that aren\(cqt advertised in the descriptor\&.


This directive can be specified multiple times so you don\(cqt have to put it all on one line\&.


Policies are considered first to last, and the first match wins\&. If you want to allow the same ports on IPv4 and IPv6, write your rules using accept/reject *\&. If you want to allow different ports on IPv4 and IPv6, write your IPv6 rules using accept6/reject6 *6, and your IPv4 rules using accept/reject *4\&. If you want to _replace_ the default exit policy, end your exit policy with either a reject *:* or an accept *:*\&. Otherwise, you\(cqre _augmenting_ (prepending to) the default exit policy\&. The default exit policy is:

.sp
.if n \{\
.RS 4
.\}
.nf
reject *:25
reject *:119
reject *:135\-139
reject *:445
reject *:563
reject *:1214
reject *:4661\-4666
reject *:6346\-6429
reject *:6699
reject *:6881\-6999
accept *:*
.fi
.if n \{\
.RE
.\}
.RE
.PP
.RS 4
Since the default exit policy uses accept/reject *, it applies to both IPv4 and IPv6 addresses\&.
.RE
.PP
\fBExitPolicyRejectPrivate\fR \fB0\fR|\fB1\fR
.RS 4
Reject all private (local) networks, along with the relay\(cqs advertised public IPv4 and IPv6 addresses, at the beginning of your exit policy\&. See above entry on ExitPolicy\&. (Default: 1)
.RE
.PP
\fBExitPolicyRejectLocalInterfaces\fR \fB0\fR|\fB1\fR
.RS 4
Reject all IPv4 and IPv6 addresses that the relay knows about, at the beginning of your exit policy\&. This includes any OutboundBindAddress, the bind addresses of any port options, such as ControlPort or DNSPort, and any public IPv4 and IPv6 addresses on any interface on the relay\&. (If IPv6Exit is not set, all IPv6 addresses will be rejected anyway\&.) See above entry on ExitPolicy\&. This option is off by default, because it lists all public relay IP addresses in the ExitPolicy, even those relay operators might prefer not to disclose\&. (Default: 0)
.RE
.PP
\fBIPv6Exit\fR \fB0\fR|\fB1\fR
.RS 4
If set, and we are an exit node, allow clients to use us for IPv6 traffic\&. (Default: 0)
.RE
.PP
\fBMaxOnionQueueDelay\fR \fINUM\fR [\fBmsec\fR|\fBsecond\fR]
.RS 4
If we have more onionskins queued for processing than we can process in this amount of time, reject new ones\&. (Default: 1750 msec)
.RE
.PP
\fBMyFamily\fR \fIfingerprint\fR,\fIfingerprint\fR,\&...
.RS 4
Declare that this Tor relay is controlled or administered by a group or organization identical or similar to that of the other relays, defined by their (possibly $\-prefixed) identity fingerprints\&. This option can be repeated many times, for convenience in defining large families: all fingerprints in all MyFamily lines are merged into one list\&. When two relays both declare that they are in the same \*(Aqfamily\*(Aq, Tor clients will not use them in the same circuit\&. (Each relay only needs to list the other servers in its family; it doesn\(cqt need to list itself, but it won\(cqt hurt if it does\&.) Do not list any bridge relay as it would compromise its concealment\&.


When listing a node, it\(cqs better to list it by fingerprint than by nickname: fingerprints are more reliable\&.
.RE
.PP
\fBNickname\fR \fIname\fR
.RS 4
Set the server\(cqs nickname to \*(Aqname\*(Aq\&. Nicknames must be between 1 and 19 characters inclusive, and must contain only the characters [a\-zA\-Z0\-9]\&.
.RE
.PP
\fBNumCPUs\fR \fInum\fR
.RS 4
How many processes to use at once for decrypting onionskins and other parallelizable operations\&. If this is set to 0, Tor will try to detect how many CPUs you have, defaulting to 1 if it can\(cqt tell\&. (Default: 0)
.RE
.PP
\fBORPort\fR [\fIaddress\fR:]\fIPORT\fR|\fBauto\fR [\fIflags\fR]
.RS 4
Advertise this port to listen for connections from Tor clients and servers\&. This option is required to be a Tor server\&. Set it to "auto" to have Tor pick a port for you\&. Set it to 0 to not run an ORPort at all\&. This option can occur more than once\&. (Default: 0)


Tor recognizes these flags on each ORPort:
.PP
\fBNoAdvertise\fR
.RS 4
By default, we bind to a port and tell our users about it\&. If NoAdvertise is specified, we don\(cqt advertise, but listen anyway\&. This can be useful if the port everybody will be connecting to (for example, one that\(cqs opened on our firewall) is somewhere else\&.
.RE
.PP
\fBNoListen\fR
.RS 4
By default, we bind to a port and tell our users about it\&. If NoListen is specified, we don\(cqt bind, but advertise anyway\&. This can be useful if something else (for example, a firewall\(cqs port forwarding configuration) is causing connections to reach us\&.
.RE
.PP
\fBIPv4Only\fR
.RS 4
If the address is absent, or resolves to both an IPv4 and an IPv6 address, only listen to the IPv4 address\&.
.RE
.PP
\fBIPv6Only\fR
.RS 4
If the address is absent, or resolves to both an IPv4 and an IPv6 address, only listen to the IPv6 address\&.
.RE
.RE
.PP
.RS 4
For obvious reasons, NoAdvertise and NoListen are mutually exclusive, and IPv4Only and IPv6Only are mutually exclusive\&.
.RE
.PP
\fBPortForwarding\fR \fB0\fR|\fB1\fR
.RS 4
Attempt to automatically forward the DirPort and ORPort on a NAT router connecting this Tor server to the Internet\&. If set, Tor will try both NAT\-PMP (common on Apple routers) and UPnP (common on routers from other manufacturers)\&. (Default: 0)
.RE
.PP
\fBPortForwardingHelper\fR \fIfilename\fR|\fIpathname\fR
.RS 4
If PortForwarding is set, use this executable to configure the forwarding\&. If set to a filename, the system path will be searched for the executable\&. If set to a path, only the specified path will be executed\&. (Default: tor\-fw\-helper)
.RE
.PP
\fBPublishServerDescriptor\fR \fB0\fR|\fB1\fR|\fBv3\fR|\fBbridge\fR,\fB\&...\fR
.RS 4
This option specifies which descriptors Tor will publish when acting as a relay\&. You can choose multiple arguments, separated by commas\&.


If this option is set to 0, Tor will not publish its descriptors to any directories\&. (This is useful if you\(cqre testing out your server, or if you\(cqre using a Tor controller that handles directory publishing for you\&.) Otherwise, Tor will publish its descriptors of all type(s) specified\&. The default is "1", which means "if running as a server, publish the appropriate descriptors to the authorities"\&.
.RE
.PP
\fBShutdownWaitLength\fR \fINUM\fR
.RS 4
When we get a SIGINT and we\(cqre a server, we begin shutting down: we close listeners and start refusing new circuits\&. After
\fBNUM\fR
seconds, we exit\&. If we get a second SIGINT, we exit immediately\&. (Default: 30 seconds)
.RE
.PP
\fBSSLKeyLifetime\fR \fIN\fR \fBminutes\fR|\fBhours\fR|\fBdays\fR|\fBweeks\fR
.RS 4
When creating a link certificate for our outermost SSL handshake, set its lifetime to this amount of time\&. If set to 0, Tor will choose some reasonable random defaults\&. (Default: 0)
.RE
.PP
\fBHeartbeatPeriod\fR \fIN\fR \fBminutes\fR|\fBhours\fR|\fBdays\fR|\fBweeks\fR
.RS 4
Log a heartbeat message every
\fBHeartbeatPeriod\fR
seconds\&. This is a log level
\fInotice\fR
message, designed to let you know your Tor server is still alive and doing useful things\&. Settings this to 0 will disable the heartbeat\&. Otherwise, it must be at least 30 minutes\&. (Default: 6 hours)
.RE
.PP
\fBAccountingMax\fR \fIN\fR \fBbytes\fR|\fBKBytes\fR|\fBMBytes\fR|\fBGBytes\fR|\fBTBytes\fR|\fBKBits\fR|\fBMBits\fR|\fBGBits\fR|\fBTBits\fR
.RS 4
Limits the max number of bytes sent and received within a set time period using a given calculation rule (see: AccountingStart, AccountingRule)\&. Useful if you need to stay under a specific bandwidth\&. By default, the number used for calculation is the max of either the bytes sent or received\&. For example, with AccountingMax set to 1 GByte, a server could send 900 MBytes and receive 800 MBytes and continue running\&. It will only hibernate once one of the two reaches 1 GByte\&. This can be changed to use the sum of the both bytes received and sent by setting the AccountingRule option to "sum" (total bandwidth in/out)\&. When the number of bytes remaining gets low, Tor will stop accepting new connections and circuits\&. When the number of bytes is exhausted, Tor will hibernate until some time in the next accounting period\&. To prevent all servers from waking at the same time, Tor will also wait until a random point in each period before waking up\&. If you have bandwidth cost issues, enabling hibernation is preferable to setting a low bandwidth, since it provides users with a collection of fast servers that are up some of the time, which is more useful than a set of slow servers that are always "available"\&.
.RE
.PP
\fBAccountingRule\fR \fBsum\fR|\fBmax\fR|\fBin\fR|\fBout\fR
.RS 4
How we determine when our AccountingMax has been reached (when we should hibernate) during a time interval\&. Set to "max" to calculate using the higher of either the sent or received bytes (this is the default functionality)\&. Set to "sum" to calculate using the sent plus received bytes\&. Set to "in" to calculate using only the received bytes\&. Set to "out" to calculate using only the sent bytes\&. (Default: max)
.RE
.PP
\fBAccountingStart\fR \fBday\fR|\fBweek\fR|\fBmonth\fR [\fIday\fR] \fIHH:MM\fR
.RS 4
Specify how long accounting periods last\&. If
\fBmonth\fR
is given, each accounting period runs from the time
\fIHH:MM\fR
on the
\fIdayth\fR
day of one month to the same day and time of the next\&. (The day must be between 1 and 28\&.) If
\fBweek\fR
is given, each accounting period runs from the time
\fIHH:MM\fR
of the
\fIdayth\fR
day of one week to the same day and time of the next week, with Monday as day 1 and Sunday as day 7\&. If
\fBday\fR
is given, each accounting period runs from the time
\fIHH:MM\fR
each day to the same time on the next day\&. All times are local, and given in 24\-hour time\&. (Default: "month 1 0:00")
.RE
.PP
\fBRefuseUnknownExits\fR \fB0\fR|\fB1\fR|\fBauto\fR
.RS 4
Prevent nodes that don\(cqt appear in the consensus from exiting using this relay\&. If the option is 1, we always block exit attempts from such nodes; if it\(cqs 0, we never do, and if the option is "auto", then we do whatever the authorities suggest in the consensus (and block if the consensus is quiet on the issue)\&. (Default: auto)
.RE
.PP
\fBServerDNSResolvConfFile\fR \fIfilename\fR
.RS 4
Overrides the default DNS configuration with the configuration in
\fIfilename\fR\&. The file format is the same as the standard Unix "\fBresolv\&.conf\fR" file (7)\&. This option, like all other ServerDNS options, only affects name lookups that your server does on behalf of clients\&. (Defaults to use the system DNS configuration\&.)
.RE
.PP
\fBServerDNSAllowBrokenConfig\fR \fB0\fR|\fB1\fR
.RS 4
If this option is false, Tor exits immediately if there are problems parsing the system DNS configuration or connecting to nameservers\&. Otherwise, Tor continues to periodically retry the system nameservers until it eventually succeeds\&. (Default: 1)
.RE
.PP
\fBServerDNSSearchDomains\fR \fB0\fR|\fB1\fR
.RS 4
If set to 1, then we will search for addresses in the local search domain\&. For example, if this system is configured to believe it is in "example\&.com", and a client tries to connect to "www", the client will be connected to "www\&.example\&.com"\&. This option only affects name lookups that your server does on behalf of clients\&. (Default: 0)
.RE
.PP
\fBServerDNSDetectHijacking\fR \fB0\fR|\fB1\fR
.RS 4
When this option is set to 1, we will test periodically to determine whether our local nameservers have been configured to hijack failing DNS requests (usually to an advertising site)\&. If they are, we will attempt to correct this\&. This option only affects name lookups that your server does on behalf of clients\&. (Default: 1)
.RE
.PP
\fBServerDNSTestAddresses\fR \fIaddress\fR,\fIaddress\fR,\fI\&...\fR
.RS 4
When we\(cqre detecting DNS hijacking, make sure that these
\fIvalid\fR
addresses aren\(cqt getting redirected\&. If they are, then our DNS is completely useless, and we\(cqll reset our exit policy to "reject *:*"\&. This option only affects name lookups that your server does on behalf of clients\&. (Default: "www\&.google\&.com, www\&.mit\&.edu, www\&.yahoo\&.com, www\&.slashdot\&.org")
.RE
.PP
\fBServerDNSAllowNonRFC953Hostnames\fR \fB0\fR|\fB1\fR
.RS 4
When this option is disabled, Tor does not try to resolve hostnames containing illegal characters (like @ and :) rather than sending them to an exit node to be resolved\&. This helps trap accidental attempts to resolve URLs and so on\&. This option only affects name lookups that your server does on behalf of clients\&. (Default: 0)
.RE
.PP
\fBBridgeRecordUsageByCountry\fR \fB0\fR|\fB1\fR
.RS 4
When this option is enabled and BridgeRelay is also enabled, and we have GeoIP data, Tor keeps a per\-country count of how many client addresses have contacted it so that it can help the bridge authority guess which countries have blocked access to it\&. (Default: 1)
.RE
.PP
\fBServerDNSRandomizeCase\fR \fB0\fR|\fB1\fR
.RS 4
When this option is set, Tor sets the case of each character randomly in outgoing DNS requests, and makes sure that the case matches in DNS replies\&. This so\-called "0x20 hack" helps resist some types of DNS poisoning attack\&. For more information, see "Increased DNS Forgery Resistance through 0x20\-Bit Encoding"\&. This option only affects name lookups that your server does on behalf of clients\&. (Default: 1)
.RE
.PP
\fBGeoIPFile\fR \fIfilename\fR
.RS 4
A filename containing IPv4 GeoIP data, for use with by\-country statistics\&.
.RE
.PP
\fBGeoIPv6File\fR \fIfilename\fR
.RS 4
A filename containing IPv6 GeoIP data, for use with by\-country statistics\&.
.RE
.PP
\fBCellStatistics\fR \fB0\fR|\fB1\fR
.RS 4
Relays only\&. When this option is enabled, Tor collects statistics about cell processing (i\&.e\&. mean time a cell is spending in a queue, mean number of cells in a queue and mean number of processed cells per circuit) and writes them into disk every 24 hours\&. Onion router operators may use the statistics for performance monitoring\&. If ExtraInfoStatistics is enabled, it will published as part of extra\-info document\&. (Default: 0)
.RE
.PP
\fBPaddingStatistics\fR \fB0\fR|\fB1\fR
.RS 4
Relays only\&. When this option is enabled, Tor collects statistics for padding cells sent and received by this relay, in addition to total cell counts\&. These statistics are rounded, and omitted if traffic is low\&. This information is important for load balancing decisions related to padding\&. (Default: 1)
.RE
.PP
\fBDirReqStatistics\fR \fB0\fR|\fB1\fR
.RS 4
Relays and bridges only\&. When this option is enabled, a Tor directory writes statistics on the number and response time of network status requests to disk every 24 hours\&. Enables relay and bridge operators to monitor how much their server is being used by clients to learn about Tor network\&. If ExtraInfoStatistics is enabled, it will published as part of extra\-info document\&. (Default: 1)
.RE
.PP
\fBEntryStatistics\fR \fB0\fR|\fB1\fR
.RS 4
Relays only\&. When this option is enabled, Tor writes statistics on the number of directly connecting clients to disk every 24 hours\&. Enables relay operators to monitor how much inbound traffic that originates from Tor clients passes through their server to go further down the Tor network\&. If ExtraInfoStatistics is enabled, it will be published as part of extra\-info document\&. (Default: 0)
.RE
.PP
\fBExitPortStatistics\fR \fB0\fR|\fB1\fR
.RS 4
Exit relays only\&. When this option is enabled, Tor writes statistics on the number of relayed bytes and opened stream per exit port to disk every 24 hours\&. Enables exit relay operators to measure and monitor amounts of traffic that leaves Tor network through their exit node\&. If ExtraInfoStatistics is enabled, it will be published as part of extra\-info document\&. (Default: 0)
.RE
.PP
\fBConnDirectionStatistics\fR \fB0\fR|\fB1\fR
.RS 4
Relays only\&. When this option is enabled, Tor writes statistics on the amounts of traffic it passes between itself and other relays to disk every 24 hours\&. Enables relay operators to monitor how much their relay is being used as middle node in the circuit\&. If ExtraInfoStatistics is enabled, it will be published as part of extra\-info document\&. (Default: 0)
.RE
.PP
\fBHiddenServiceStatistics\fR \fB0\fR|\fB1\fR
.RS 4
Relays only\&. When this option is enabled, a Tor relay writes obfuscated statistics on its role as hidden\-service directory, introduction point, or rendezvous point to disk every 24 hours\&. If ExtraInfoStatistics is also enabled, these statistics are further published to the directory authorities\&. (Default: 1)
.RE
.PP
\fBExtraInfoStatistics\fR \fB0\fR|\fB1\fR
.RS 4
When this option is enabled, Tor includes previously gathered statistics in its extra\-info documents that it uploads to the directory authorities\&. (Default: 1)
.RE
.PP
\fBExtendAllowPrivateAddresses\fR \fB0\fR|\fB1\fR
.RS 4
When this option is enabled, Tor will connect to relays on localhost, RFC1918 addresses, and so on\&. In particular, Tor will make direct OR connections, and Tor routers allow EXTEND requests, to these private addresses\&. (Tor will always allow connections to bridges, proxies, and pluggable transports configured on private addresses\&.) Enabling this option can create security issues; you should probably leave it off\&. (Default: 0)
.RE
.PP
\fBMaxMemInQueues\fR \fIN\fR \fBbytes\fR|\fBKB\fR|\fBMB\fR|\fBGB\fR
.RS 4
This option configures a threshold above which Tor will assume that it needs to stop queueing or buffering data because it\(cqs about to run out of memory\&. If it hits this threshold, it will begin killing circuits until it has recovered at least 10% of this memory\&. Do not set this option too low, or your relay may be unreliable under load\&. This option only affects some queues, so the actual process size will be larger than this\&. If this option is set to 0, Tor will try to pick a reasonable default based on your system\(cqs physical memory\&. (Default: 0)
.RE
.PP
\fBDisableOOSCheck\fR \fB0\fR|\fB1\fR
.RS 4
This option disables the code that closes connections when Tor notices that it is running low on sockets\&. Right now, it is on by default, since the existing out\-of\-sockets mechanism tends to kill OR connections more than it should\&. (Default: 1)
.RE
.PP
\fBSigningKeyLifetime\fR \fIN\fR \fBdays\fR|\fBweeks\fR|\fBmonths\fR
.RS 4
For how long should each Ed25519 signing key be valid? Tor uses a permanent master identity key that can be kept offline, and periodically generates new "signing" keys that it uses online\&. This option configures their lifetime\&. (Default: 30 days)
.RE
.PP
\fBOfflineMasterKey\fR \fB0\fR|\fB1\fR
.RS 4
If non\-zero, the Tor relay will never generate or load its master secret key\&. Instead, you\(cqll have to use "tor \-\-keygen" to manage the permanent ed25519 master identity key, as well as the corresponding temporary signing keys and certificates\&. (Default: 0)
.RE
.SH "DIRECTORY SERVER OPTIONS"
.sp
The following options are useful only for directory servers\&. (Relays with enough bandwidth automatically become directory servers; see DirCache for details\&.)
.PP
\fBDirPortFrontPage\fR \fIFILENAME\fR
.RS 4
When this option is set, it takes an HTML file and publishes it as "/" on the DirPort\&. Now relay operators can provide a disclaimer without needing to set up a separate webserver\&. There\(cqs a sample disclaimer in contrib/operator\-tools/tor\-exit\-notice\&.html\&.
.RE
.PP
\fBDirPort\fR [\fIaddress\fR:]\fIPORT\fR|\fBauto\fR [\fIflags\fR]
.RS 4
If this option is nonzero, advertise the directory service on this port\&. Set it to "auto" to have Tor pick a port for you\&. This option can occur more than once, but only one advertised DirPort is supported: all but one DirPort must have the
\fBNoAdvertise\fR
flag set\&. (Default: 0)


The same flags are supported here as are supported by ORPort\&.
.RE
.PP
\fBDirPolicy\fR \fIpolicy\fR,\fIpolicy\fR,\fI\&...\fR
.RS 4
Set an entrance policy for this server, to limit who can connect to the directory ports\&. The policies have the same form as exit policies above, except that port specifiers are ignored\&. Any address not matched by some entry in the policy is accepted\&.
.RE
.PP
\fBDirCache\fR \fB0\fR|\fB1\fR
.RS 4
When this option is set, Tor caches all current directory documents and accepts client requests for them\&. Setting DirPort is not required for this, because clients connect via the ORPort by default\&. Setting either DirPort or BridgeRelay and setting DirCache to 0 is not supported\&. (Default: 1)
.RE
.PP
\fBMaxConsensusAgeForDiffs\fR \fIN\fR \fBminutes\fR|\fBhours\fR|\fBdays\fR|\fBweeks\fR
.RS 4
When this option is nonzero, Tor caches will not try to generate consensus diffs for any consensus older than this amount of time\&. If this option is set to zero, Tor will pick a reasonable default from the current networkstatus document\&. You should not set this option unless your cache is severely low on disk space or CPU\&. If you need to set it, keeping it above 3 or 4 hours will help clients much more than setting it to zero\&. (Default: 0)
.RE
.SH "DIRECTORY AUTHORITY SERVER OPTIONS"
.sp
The following options enable operation as a directory authority, and control how Tor behaves as a directory authority\&. You should not need to adjust any of them if you\(cqre running a regular relay or exit server on the public Tor network\&.
.PP
\fBAuthoritativeDirectory\fR \fB0\fR|\fB1\fR
.RS 4
When this option is set to 1, Tor operates as an authoritative directory server\&. Instead of caching the directory, it generates its own list of good servers, signs it, and sends that to the clients\&. Unless the clients already have you listed as a trusted directory, you probably do not want to set this option\&.
.RE
.PP
\fBV3AuthoritativeDirectory\fR \fB0\fR|\fB1\fR
.RS 4
When this option is set in addition to
\fBAuthoritativeDirectory\fR, Tor generates version 3 network statuses and serves descriptors, etc as described in dir\-spec\&.txt file of
torspec
(for Tor clients and servers running at least 0\&.2\&.0\&.x)\&.
.RE
.PP
\fBVersioningAuthoritativeDirectory\fR \fB0\fR|\fB1\fR
.RS 4
When this option is set to 1, Tor adds information on which versions of Tor are still believed safe for use to the published directory\&. Each version 1 authority is automatically a versioning authority; version 2 authorities provide this service optionally\&. See
\fBRecommendedVersions\fR,
\fBRecommendedClientVersions\fR, and
\fBRecommendedServerVersions\fR\&.
.RE
.PP
\fBRecommendedVersions\fR \fISTRING\fR
.RS 4
STRING is a comma\-separated list of Tor versions currently believed to be safe\&. The list is included in each directory, and nodes which pull down the directory learn whether they need to upgrade\&. This option can appear multiple times: the values from multiple lines are spliced together\&. When this is set then
\fBVersioningAuthoritativeDirectory\fR
should be set too\&.
.RE
.PP
\fBRecommendedPackages\fR \fIPACKAGENAME\fR \fIVERSION\fR \fIURL\fR \fIDIGESTTYPE\fR\fB=\fR\fIDIGEST\fR
.RS 4
Adds "package" line to the directory authority\(cqs vote\&. This information is used to vote on the correct URL and digest for the released versions of different Tor\-related packages, so that the consensus can certify them\&. This line may appear any number of times\&.
.RE
.PP
\fBRecommendedClientVersions\fR \fISTRING\fR
.RS 4
STRING is a comma\-separated list of Tor versions currently believed to be safe for clients to use\&. This information is included in version 2 directories\&. If this is not set then the value of
\fBRecommendedVersions\fR
is used\&. When this is set then
\fBVersioningAuthoritativeDirectory\fR
should be set too\&.
.RE
.PP
\fBBridgeAuthoritativeDir\fR \fB0\fR|\fB1\fR
.RS 4
When this option is set in addition to
\fBAuthoritativeDirectory\fR, Tor accepts and serves server descriptors, but it caches and serves the main networkstatus documents rather than generating its own\&. (Default: 0)
.RE
.PP
\fBMinUptimeHidServDirectoryV2\fR \fIN\fR \fBseconds\fR|\fBminutes\fR|\fBhours\fR|\fBdays\fR|\fBweeks\fR
.RS 4
Minimum uptime of a v2 hidden service directory to be accepted as such by authoritative directories\&. (Default: 25 hours)
.RE
.PP
\fBRecommendedServerVersions\fR \fISTRING\fR
.RS 4
STRING is a comma\-separated list of Tor versions currently believed to be safe for servers to use\&. This information is included in version 2 directories\&. If this is not set then the value of
\fBRecommendedVersions\fR
is used\&. When this is set then
\fBVersioningAuthoritativeDirectory\fR
should be set too\&.
.RE
.PP
\fBConsensusParams\fR \fISTRING\fR
.RS 4
STRING is a space\-separated list of key=value pairs that Tor will include in the "params" line of its networkstatus vote\&.
.RE
.PP
\fBDirAllowPrivateAddresses\fR \fB0\fR|\fB1\fR
.RS 4
If set to 1, Tor will accept server descriptors with arbitrary "Address" elements\&. Otherwise, if the address is not an IP address or is a private IP address, it will reject the server descriptor\&. Additionally, Tor will allow exit policies for private networks to fulfill Exit flag requirements\&. (Default: 0)
.RE
.PP
\fBAuthDirBadExit\fR \fIAddressPattern\&...\fR
.RS 4
Authoritative directories only\&. A set of address patterns for servers that will be listed as bad exits in any network status document this authority publishes, if
\fBAuthDirListBadExits\fR
is set\&.


(The address pattern syntax here and in the options below is the same as for exit policies, except that you don\(cqt need to say "accept" or "reject", and ports are not needed\&.)
.RE
.PP
\fBAuthDirInvalid\fR \fIAddressPattern\&...\fR
.RS 4
Authoritative directories only\&. A set of address patterns for servers that will never be listed as "valid" in any network status document that this authority publishes\&.
.RE
.PP
\fBAuthDirReject\fR \fIAddressPattern\fR\&...
.RS 4
Authoritative directories only\&. A set of address patterns for servers that will never be listed at all in any network status document that this authority publishes, or accepted as an OR address in any descriptor submitted for publication by this authority\&.
.RE
.sp
\fBAuthDirBadExitCCs\fR \fICC\fR,\&...
.sp
\fBAuthDirInvalidCCs\fR \fICC\fR,\&...
.PP
\fBAuthDirRejectCCs\fR \fICC\fR,\&...
.RS 4
Authoritative directories only\&. These options contain a comma\-separated list of country codes such that any server in one of those country codes will be marked as a bad exit/invalid for use, or rejected entirely\&.
.RE
.PP
\fBAuthDirListBadExits\fR \fB0\fR|\fB1\fR
.RS 4
Authoritative directories only\&. If set to 1, this directory has some opinion about which nodes are unsuitable as exit nodes\&. (Do not set this to 1 unless you plan to list non\-functioning exits as bad; otherwise, you are effectively voting in favor of every declared exit as an exit\&.)
.RE
.PP
\fBAuthDirMaxServersPerAddr\fR \fINUM\fR
.RS 4
Authoritative directories only\&. The maximum number of servers that we will list as acceptable on a single IP address\&. Set this to "0" for "no limit"\&. (Default: 2)
.RE
.PP
\fBAuthDirFastGuarantee\fR \fIN\fR \fBbytes\fR|\fBKBytes\fR|\fBMBytes\fR|\fBGBytes\fR|\fBTBytes\fR|\fBKBits\fR|\fBMBits\fR|\fBGBits\fR|\fBTBits\fR
.RS 4
Authoritative directories only\&. If non\-zero, always vote the Fast flag for any relay advertising this amount of capacity or more\&. (Default: 100 KBytes)
.RE
.PP
\fBAuthDirGuardBWGuarantee\fR \fIN\fR \fBbytes\fR|\fBKBytes\fR|\fBMBytes\fR|\fBGBytes\fR|\fBTBytes\fR|\fBKBits\fR|\fBMBits\fR|\fBGBits\fR|\fBTBits\fR
.RS 4
Authoritative directories only\&. If non\-zero, this advertised capacity or more is always sufficient to satisfy the bandwidth requirement for the Guard flag\&. (Default: 2 MBytes)
.RE
.PP
\fBAuthDirPinKeys\fR \fB0\fR|\fB1\fR
.RS 4
Authoritative directories only\&. If non\-zero, do not allow any relay to publish a descriptor if any other relay has reserved its <Ed25519,RSA> identity keypair\&. In all cases, Tor records every keypair it accepts in a journal if it is new, or if it differs from the most recently accepted pinning for one of the keys it contains\&. (Default: 1)
.RE
.PP
\fBAuthDirSharedRandomness\fR \fB0\fR|\fB1\fR
.RS 4
Authoritative directories only\&. Switch for the shared random protocol\&. If zero, the authority won\(cqt participate in the protocol\&. If non\-zero (default), the flag "shared\-rand\-participate" is added to the authority vote indicating participation in the protocol\&. (Default: 1)
.RE
.PP
\fBAuthDirTestEd25519LinkKeys\fR \fB0\fR|\fB1\fR
.RS 4
Authoritative directories only\&. If this option is set to 0, then we treat relays as "Running" if their RSA key is correct when we probe them, regardless of their Ed25519 key\&. We should only ever set this option to 0 if there is some major bug in Ed25519 link authentication that causes us to label all the relays as not Running\&. (Default: 1)
.RE
.PP
\fBBridgePassword\fR \fIPassword\fR
.RS 4
If set, contains an HTTP authenticator that tells a bridge authority to serve all requested bridge information\&. Used by the (only partially implemented) "bridge community" design, where a community of bridge relay operators all use an alternate bridge directory authority, and their target user audience can periodically fetch the list of available community bridges to stay up\-to\-date\&. (Default: not set)
.RE
.PP
\fBV3AuthVotingInterval\fR \fIN\fR \fBminutes\fR|\fBhours\fR
.RS 4
V3 authoritative directories only\&. Configures the server\(cqs preferred voting interval\&. Note that voting will
\fIactually\fR
happen at an interval chosen by consensus from all the authorities\*(Aq preferred intervals\&. This time SHOULD divide evenly into a day\&. (Default: 1 hour)
.RE
.PP
\fBV3AuthVoteDelay\fR \fIN\fR \fBminutes\fR|\fBhours\fR
.RS 4
V3 authoritative directories only\&. Configures the server\(cqs preferred delay between publishing its vote and assuming it has all the votes from all the other authorities\&. Note that the actual time used is not the server\(cqs preferred time, but the consensus of all preferences\&. (Default: 5 minutes)
.RE
.PP
\fBV3AuthDistDelay\fR \fIN\fR \fBminutes\fR|\fBhours\fR
.RS 4
V3 authoritative directories only\&. Configures the server\(cqs preferred delay between publishing its consensus and signature and assuming it has all the signatures from all the other authorities\&. Note that the actual time used is not the server\(cqs preferred time, but the consensus of all preferences\&. (Default: 5 minutes)
.RE
.PP
\fBV3AuthNIntervalsValid\fR \fINUM\fR
.RS 4
V3 authoritative directories only\&. Configures the number of VotingIntervals for which each consensus should be valid for\&. Choosing high numbers increases network partitioning risks; choosing low numbers increases directory traffic\&. Note that the actual number of intervals used is not the server\(cqs preferred number, but the consensus of all preferences\&. Must be at least 2\&. (Default: 3)
.RE
.PP
\fBV3BandwidthsFile\fR \fIFILENAME\fR
.RS 4
V3 authoritative directories only\&. Configures the location of the bandwidth\-authority generated file storing information on relays\*(Aq measured bandwidth capacities\&. (Default: unset)
.RE
.PP
\fBV3AuthUseLegacyKey\fR \fB0\fR|\fB1\fR
.RS 4
If set, the directory authority will sign consensuses not only with its own signing key, but also with a "legacy" key and certificate with a different identity\&. This feature is used to migrate directory authority keys in the event of a compromise\&. (Default: 0)
.RE
.PP
\fBRephistTrackTime\fR \fIN\fR \fBseconds\fR|\fBminutes\fR|\fBhours\fR|\fBdays\fR|\fBweeks\fR
.RS 4
Tells an authority, or other node tracking node reliability and history, that fine\-grained information about nodes can be discarded when it hasn\(cqt changed for a given amount of time\&. (Default: 24 hours)
.RE
.PP
\fBAuthDirHasIPv6Connectivity\fR \fB0\fR|\fB1\fR
.RS 4
Authoritative directories only\&. When set to 0, OR ports with an IPv6 address are being accepted without reachability testing\&. When set to 1, IPv6 OR ports are being tested just like IPv4 OR ports\&. (Default: 0)
.RE
.PP
\fBMinMeasuredBWsForAuthToIgnoreAdvertised\fR \fIN\fR
.RS 4
A total value, in abstract bandwidth units, describing how much measured total bandwidth an authority should have observed on the network before it will treat advertised bandwidths as wholly unreliable\&. (Default: 500)
.RE
.SH "HIDDEN SERVICE OPTIONS"
.sp
The following options are used to configure a hidden service\&.
.PP
\fBHiddenServiceDir\fR \fIDIRECTORY\fR
.RS 4
Store data files for a hidden service in DIRECTORY\&. Every hidden service must have a separate directory\&. You may use this option multiple times to specify multiple services\&. If DIRECTORY does not exist, Tor will create it\&. (Note: in current versions of Tor, if DIRECTORY is a relative path, it will be relative to the current working directory of Tor instance, not to its DataDirectory\&. Do not rely on this behavior; it is not guaranteed to remain the same in future versions\&.)
.RE
.PP
\fBHiddenServicePort\fR \fIVIRTPORT\fR [\fITARGET\fR]
.RS 4
Configure a virtual port VIRTPORT for a hidden service\&. You may use this option multiple times; each time applies to the service using the most recent HiddenServiceDir\&. By default, this option maps the virtual port to the same port on 127\&.0\&.0\&.1 over TCP\&. You may override the target port, address, or both by specifying a target of addr, port, addr:port, or
\fBunix:\fR\fIpath\fR\&. (You can specify an IPv6 target as [addr]:port\&. Unix paths may be quoted, and may use standard C escapes\&.) You may also have multiple lines with the same VIRTPORT: when a user connects to that VIRTPORT, one of the TARGETs from those lines will be chosen at random\&.
.RE
.PP
\fBPublishHidServDescriptors\fR \fB0\fR|\fB1\fR
.RS 4
If set to 0, Tor will run any hidden services you configure, but it won\(cqt advertise them to the rendezvous directory\&. This option is only useful if you\(cqre using a Tor controller that handles hidserv publishing for you\&. (Default: 1)
.RE
.PP
\fBHiddenServiceVersion\fR \fIversion\fR,\fIversion\fR,\fI\&...\fR
.RS 4
A list of rendezvous service descriptor versions to publish for the hidden service\&. Currently, only version 2 is supported\&. (Default: 2)
.RE
.PP
\fBHiddenServiceAuthorizeClient\fR \fIauth\-type\fR \fIclient\-name\fR,\fIclient\-name\fR,\fI\&...\fR
.RS 4
If configured, the hidden service is accessible for authorized clients only\&. The auth\-type can either be \*(Aqbasic\*(Aq for a general\-purpose authorization protocol or \*(Aqstealth\*(Aq for a less scalable protocol that also hides service activity from unauthorized clients\&. Only clients that are listed here are authorized to access the hidden service\&. Valid client names are 1 to 16 characters long and only use characters in A\-Za\-z0\-9+\-_ (no spaces)\&. If this option is set, the hidden service is not accessible for clients without authorization any more\&. Generated authorization data can be found in the hostname file\&. Clients need to put this authorization data in their configuration file using
\fBHidServAuth\fR\&.
.RE
.PP
\fBHiddenServiceAllowUnknownPorts\fR \fB0\fR|\fB1\fR
.RS 4
If set to 1, then connections to unrecognized ports do not cause the current hidden service to close rendezvous circuits\&. (Setting this to 0 is not an authorization mechanism; it is instead meant to be a mild inconvenience to port\-scanners\&.) (Default: 0)
.RE
.PP
\fBHiddenServiceMaxStreams\fR \fIN\fR
.RS 4
The maximum number of simultaneous streams (connections) per rendezvous circuit\&. The maximum value allowed is 65535\&. (Setting this to 0 will allow an unlimited number of simultanous streams\&.) (Default: 0)
.RE
.PP
\fBHiddenServiceMaxStreamsCloseCircuit\fR \fB0\fR|\fB1\fR
.RS 4
If set to 1, then exceeding
\fBHiddenServiceMaxStreams\fR
will cause the offending rendezvous circuit to be torn down, as opposed to stream creation requests that exceed the limit being silently ignored\&. (Default: 0)
.RE
.PP
\fBRendPostPeriod\fR \fIN\fR \fBseconds\fR|\fBminutes\fR|\fBhours\fR|\fBdays\fR|\fBweeks\fR
.RS 4
Every time the specified period elapses, Tor uploads any rendezvous service descriptors to the directory servers\&. This information is also uploaded whenever it changes\&. Minimum value allowed is 10 minutes and maximum is 3\&.5 days\&. (Default: 1 hour)
.RE
.PP
\fBHiddenServiceDirGroupReadable\fR \fB0\fR|\fB1\fR
.RS 4
If this option is set to 1, allow the filesystem group to read the hidden service directory and hostname file\&. If the option is set to 0, only owner is able to read the hidden service directory\&. (Default: 0) Has no effect on Windows\&.
.RE
.PP
\fBHiddenServiceNumIntroductionPoints\fR \fINUM\fR
.RS 4
Number of introduction points the hidden service will have\&. You can\(cqt have more than 10\&. (Default: 3)
.RE
.PP
\fBHiddenServiceSingleHopMode\fR \fB0\fR|\fB1\fR
.RS 4
\fBExperimental \- Non Anonymous\fR
Hidden Services on a tor instance in HiddenServiceSingleHopMode make one\-hop (direct) circuits between the onion service server, and the introduction and rendezvous points\&. (Onion service descriptors are still posted using 3\-hop paths, to avoid onion service directories blocking the service\&.) This option makes every hidden service instance hosted by a tor instance a Single Onion Service\&. One\-hop circuits make Single Onion servers easily locatable, but clients remain location\-anonymous\&. However, the fact that a client is accessing a Single Onion rather than a Hidden Service may be statistically distinguishable\&.


\fBWARNING:\fR
Once a hidden service directory has been used by a tor instance in HiddenServiceSingleHopMode, it can
\fBNEVER\fR
be used again for a hidden service\&. It is best practice to create a new hidden service directory, key, and address for each new Single Onion Service and Hidden Service\&. It is not possible to run Single Onion Services and Hidden Services from the same tor instance: they should be run on different servers with different IP addresses\&.


HiddenServiceSingleHopMode requires HiddenServiceNonAnonymousMode to be set to 1\&. Since a Single Onion service is non\-anonymous, you can not configure a SOCKSPort on a tor instance that is running in
\fBHiddenServiceSingleHopMode\fR\&. Can not be changed while tor is running\&. (Default: 0)
.RE
.PP
\fBHiddenServiceNonAnonymousMode\fR \fB0\fR|\fB1\fR
.RS 4
Makes hidden services non\-anonymous on this tor instance\&. Allows the non\-anonymous HiddenServiceSingleHopMode\&. Enables direct connections in the server\-side hidden service protocol\&. If you are using this option, you need to disable all client\-side services on your Tor instance, including setting SOCKSPort to "0"\&. Can not be changed while tor is running\&. (Default: 0)
.RE
.SH "TESTING NETWORK OPTIONS"
.sp
The following options are used for running a testing Tor network\&.
.PP
\fBTestingTorNetwork\fR \fB0\fR|\fB1\fR
.RS 4
If set to 1, Tor adjusts default values of the configuration options below, so that it is easier to set up a testing Tor network\&. May only be set if non\-default set of DirAuthorities is set\&. Cannot be unset while Tor is running\&. (Default: 0)

.sp
.if n \{\
.RS 4
.\}
.nf
ServerDNSAllowBrokenConfig 1
DirAllowPrivateAddresses 1
EnforceDistinctSubnets 0
AssumeReachable 1
AuthDirMaxServersPerAddr 0
AuthDirMaxServersPerAuthAddr 0
ClientBootstrapConsensusAuthorityDownloadSchedule 0, 2,
   4 (for 40 seconds), 8, 16, 32, 60
ClientBootstrapConsensusFallbackDownloadSchedule 0, 1,
   4 (for 40 seconds), 8, 16, 32, 60
ClientBootstrapConsensusAuthorityOnlyDownloadSchedule 0, 1,
   4 (for 40 seconds), 8, 16, 32, 60
ClientBootstrapConsensusMaxDownloadTries 80
ClientBootstrapConsensusAuthorityOnlyMaxDownloadTries 80
ClientDNSRejectInternalAddresses 0
ClientRejectInternalAddresses 0
CountPrivateBandwidth 1
ExitPolicyRejectPrivate 0
ExtendAllowPrivateAddresses 1
V3AuthVotingInterval 5 minutes
V3AuthVoteDelay 20 seconds
V3AuthDistDelay 20 seconds
MinUptimeHidServDirectoryV2 0 seconds
TestingV3AuthInitialVotingInterval 5 minutes
TestingV3AuthInitialVoteDelay 20 seconds
TestingV3AuthInitialDistDelay 20 seconds
TestingAuthDirTimeToLearnReachability 0 minutes
TestingEstimatedDescriptorPropagationTime 0 minutes
TestingServerDownloadSchedule 0, 0, 0, 5, 10, 15, 20, 30, 60
TestingClientDownloadSchedule 0, 0, 5, 10, 15, 20, 30, 60
TestingServerConsensusDownloadSchedule 0, 0, 5, 10, 15, 20, 30, 60
TestingClientConsensusDownloadSchedule 0, 0, 5, 10, 15, 20, 30, 60
TestingBridgeDownloadSchedule 60, 30, 30, 60
TestingClientMaxIntervalWithoutRequest 5 seconds
TestingDirConnectionMaxStall 30 seconds
TestingConsensusMaxDownloadTries 80
TestingDescriptorMaxDownloadTries 80
TestingMicrodescMaxDownloadTries 80
TestingCertMaxDownloadTries 80
TestingEnableConnBwEvent 1
TestingEnableCellStatsEvent 1
TestingEnableTbEmptyEvent 1
.fi
.if n \{\
.RE
.\}
.RE
.PP
\fBTestingV3AuthInitialVotingInterval\fR \fIN\fR \fBminutes\fR|\fBhours\fR
.RS 4
Like V3AuthVotingInterval, but for initial voting interval before the first consensus has been created\&. Changing this requires that
\fBTestingTorNetwork\fR
is set\&. (Default: 30 minutes)
.RE
.PP
\fBTestingV3AuthInitialVoteDelay\fR \fIN\fR \fBminutes\fR|\fBhours\fR
.RS 4
Like V3AuthVoteDelay, but for initial voting interval before the first consensus has been created\&. Changing this requires that
\fBTestingTorNetwork\fR
is set\&. (Default: 5 minutes)
.RE
.PP
\fBTestingV3AuthInitialDistDelay\fR \fIN\fR \fBminutes\fR|\fBhours\fR
.RS 4
Like V3AuthDistDelay, but for initial voting interval before the first consensus has been created\&. Changing this requires that
\fBTestingTorNetwork\fR
is set\&. (Default: 5 minutes)
.RE
.PP
\fBTestingV3AuthVotingStartOffset\fR \fIN\fR \fBseconds\fR|\fBminutes\fR|\fBhours\fR
.RS 4
Directory authorities offset voting start time by this much\&. Changing this requires that
\fBTestingTorNetwork\fR
is set\&. (Default: 0)
.RE
.PP
\fBTestingAuthDirTimeToLearnReachability\fR \fIN\fR \fBminutes\fR|\fBhours\fR
.RS 4
After starting as an authority, do not make claims about whether routers are Running until this much time has passed\&. Changing this requires that
\fBTestingTorNetwork\fR
is set\&. (Default: 30 minutes)
.RE
.PP
\fBTestingEstimatedDescriptorPropagationTime\fR \fIN\fR \fBminutes\fR|\fBhours\fR
.RS 4
Clients try downloading server descriptors from directory caches after this time\&. Changing this requires that
\fBTestingTorNetwork\fR
is set\&. (Default: 10 minutes)
.RE
.PP
\fBTestingMinFastFlagThreshold\fR \fIN\fR \fBbytes\fR|\fBKBytes\fR|\fBMBytes\fR|\fBGBytes\fR|\fBTBytes\fR|\fBKBits\fR|\fBMBits\fR|\fBGBits\fR|\fBTBits\fR
.RS 4
Minimum value for the Fast flag\&. Overrides the ordinary minimum taken from the consensus when TestingTorNetwork is set\&. (Default: 0\&.)
.RE
.PP
\fBTestingServerDownloadSchedule\fR \fIN\fR,\fIN\fR,\fI\&...\fR
.RS 4
Schedule for when servers should download things in general\&. Changing this requires that
\fBTestingTorNetwork\fR
is set\&. (Default: 0, 0, 0, 60, 60, 120, 300, 900, 2147483647)
.RE
.PP
\fBTestingClientDownloadSchedule\fR \fIN\fR,\fIN\fR,\fI\&...\fR
.RS 4
Schedule for when clients should download things in general\&. Changing this requires that
\fBTestingTorNetwork\fR
is set\&. (Default: 0, 0, 60, 300, 600, 2147483647)
.RE
.PP
\fBTestingServerConsensusDownloadSchedule\fR \fIN\fR,\fIN\fR,\fI\&...\fR
.RS 4
Schedule for when servers should download consensuses\&. Changing this requires that
\fBTestingTorNetwork\fR
is set\&. (Default: 0, 0, 60, 300, 600, 1800, 1800, 1800, 1800, 1800, 3600, 7200)
.RE
.PP
\fBTestingClientConsensusDownloadSchedule\fR \fIN\fR,\fIN\fR,\fI\&...\fR
.RS 4
Schedule for when clients should download consensuses\&. Changing this requires that
\fBTestingTorNetwork\fR
is set\&. (Default: 0, 0, 60, 300, 600, 1800, 3600, 3600, 3600, 10800, 21600, 43200)
.RE
.PP
\fBTestingBridgeDownloadSchedule\fR \fIN\fR,\fIN\fR,\fI\&...\fR
.RS 4
Schedule for when clients should download bridge descriptors\&. Changing this requires that
\fBTestingTorNetwork\fR
is set\&. (Default: 3600, 900, 900, 3600)
.RE
.PP
\fBTestingClientMaxIntervalWithoutRequest\fR \fIN\fR \fBseconds\fR|\fBminutes\fR
.RS 4
When directory clients have only a few descriptors to request, they batch them until they have more, or until this amount of time has passed\&. Changing this requires that
\fBTestingTorNetwork\fR
is set\&. (Default: 10 minutes)
.RE
.PP
\fBTestingDirConnectionMaxStall\fR \fIN\fR \fBseconds\fR|\fBminutes\fR
.RS 4
Let a directory connection stall this long before expiring it\&. Changing this requires that
\fBTestingTorNetwork\fR
is set\&. (Default: 5 minutes)
.RE
.PP
\fBTestingConsensusMaxDownloadTries\fR \fINUM\fR
.RS 4
Try this many times to download a consensus before giving up\&. Changing this requires that
\fBTestingTorNetwork\fR
is set\&. (Default: 8)
.RE
.PP
\fBTestingDescriptorMaxDownloadTries\fR \fINUM\fR
.RS 4
Try this often to download a server descriptor before giving up\&. Changing this requires that
\fBTestingTorNetwork\fR
is set\&. (Default: 8)
.RE
.PP
\fBTestingMicrodescMaxDownloadTries\fR \fINUM\fR
.RS 4
Try this often to download a microdesc descriptor before giving up\&. Changing this requires that
\fBTestingTorNetwork\fR
is set\&. (Default: 8)
.RE
.PP
\fBTestingCertMaxDownloadTries\fR \fINUM\fR
.RS 4
Try this often to download a v3 authority certificate before giving up\&. Changing this requires that
\fBTestingTorNetwork\fR
is set\&. (Default: 8)
.RE
.PP
\fBTestingDirAuthVoteExit\fR \fInode\fR,\fInode\fR,\fI\&...\fR
.RS 4
A list of identity fingerprints, country codes, and address patterns of nodes to vote Exit for regardless of their uptime, bandwidth, or exit policy\&. See the
\fBExcludeNodes\fR
option for more information on how to specify nodes\&.


In order for this option to have any effect,
\fBTestingTorNetwork\fR
has to be set\&. See the
\fBExcludeNodes\fR
option for more information on how to specify nodes\&.
.RE
.PP
\fBTestingDirAuthVoteExitIsStrict\fR \fB0\fR|\fB1\fR
.RS 4
If True (1), a node will never receive the Exit flag unless it is specified in the
\fBTestingDirAuthVoteExit\fR
list, regardless of its uptime, bandwidth, or exit policy\&.


In order for this option to have any effect,
\fBTestingTorNetwork\fR
has to be set\&.
.RE
.PP
\fBTestingDirAuthVoteGuard\fR \fInode\fR,\fInode\fR,\fI\&...\fR
.RS 4
A list of identity fingerprints and country codes and address patterns of nodes to vote Guard for regardless of their uptime and bandwidth\&. See the
\fBExcludeNodes\fR
option for more information on how to specify nodes\&.


In order for this option to have any effect,
\fBTestingTorNetwork\fR
has to be set\&.
.RE
.PP
\fBTestingDirAuthVoteGuardIsStrict\fR \fB0\fR|\fB1\fR
.RS 4
If True (1), a node will never receive the Guard flag unless it is specified in the
\fBTestingDirAuthVoteGuard\fR
list, regardless of its uptime and bandwidth\&.


In order for this option to have any effect,
\fBTestingTorNetwork\fR
has to be set\&.
.RE
.PP
\fBTestingDirAuthVoteHSDir\fR \fInode\fR,\fInode\fR,\fI\&...\fR
.RS 4
A list of identity fingerprints and country codes and address patterns of nodes to vote HSDir for regardless of their uptime and DirPort\&. See the
\fBExcludeNodes\fR
option for more information on how to specify nodes\&.


In order for this option to have any effect,
\fBTestingTorNetwork\fR
must be set\&.
.RE
.PP
\fBTestingDirAuthVoteHSDirIsStrict\fR \fB0\fR|\fB1\fR
.RS 4
If True (1), a node will never receive the HSDir flag unless it is specified in the
\fBTestingDirAuthVoteHSDir\fR
list, regardless of its uptime and DirPort\&.


In order for this option to have any effect,
\fBTestingTorNetwork\fR
has to be set\&.
.RE
.PP
\fBTestingEnableConnBwEvent\fR \fB0\fR|\fB1\fR
.RS 4
If this option is set, then Tor controllers may register for CONN_BW events\&. Changing this requires that
\fBTestingTorNetwork\fR
is set\&. (Default: 0)
.RE
.PP
\fBTestingEnableCellStatsEvent\fR \fB0\fR|\fB1\fR
.RS 4
If this option is set, then Tor controllers may register for CELL_STATS events\&. Changing this requires that
\fBTestingTorNetwork\fR
is set\&. (Default: 0)
.RE
.PP
\fBTestingEnableTbEmptyEvent\fR \fB0\fR|\fB1\fR
.RS 4
If this option is set, then Tor controllers may register for TB_EMPTY events\&. Changing this requires that
\fBTestingTorNetwork\fR
is set\&. (Default: 0)
.RE
.PP
\fBTestingMinExitFlagThreshold\fR \fIN\fR \fBKBytes\fR|\fBMBytes\fR|\fBGBytes\fR|\fBTBytes\fR|\fBKBits\fR|\fBMBits\fR|\fBGBits\fR|\fBTBits\fR
.RS 4
Sets a lower\-bound for assigning an exit flag when running as an authority on a testing network\&. Overrides the usual default lower bound of 4 KB\&. (Default: 0)
.RE
.PP
\fBTestingLinkCertLifetime\fR \fIN\fR \fBseconds\fR|\fBminutes\fR|\fBhours\fR|\fBdays\fR|\fBweeks\fR|\fBmonths\fR
.RS 4
Overrides the default lifetime for the certificates used to authenticate our X509 link cert with our ed25519 signing key\&. (Default: 2 days)
.RE
.PP
\fBTestingAuthKeyLifetime\fR \fIN\fR \fBseconds\fR|\fBminutes\fR|\fBhours\fR|\fBdays\fR|\fBweeks\fR|\fBmonths\fR
.RS 4
Overrides the default lifetime for a signing Ed25519 TLS Link authentication key\&. (Default: 2 days)
.RE
.sp
\fBTestingLinkKeySlop\fR \fIN\fR \fBseconds\fR|\fBminutes\fR|\fBhours\fR
.sp
\fBTestingAuthKeySlop\fR \fIN\fR \fBseconds\fR|\fBminutes\fR|\fBhours\fR
.PP
\fBTestingSigningKeySlop\fR \fIN\fR \fBseconds\fR|\fBminutes\fR|\fBhours\fR
.RS 4
How early before the official expiration of a an Ed25519 signing key do we replace it and issue a new key? (Default: 3 hours for link and auth; 1 day for signing\&.)
.RE
.SH "NON\-PERSISTENT OPTIONS"
.sp
These options are not saved to the torrc file by the "SAVECONF" controller command\&. Other options of this type are documented in control\-spec\&.txt, section 5\&.4\&. End\-users should mostly ignore them\&.
.PP
\fB__ControlPort\fR, \fB__DirPort\fR, \fB__DNSPort\fR, \fB__ExtORPort\fR, \fB__NATDPort\fR, \fB__ORPort\fR, \fB__SocksPort\fR, \fB\e_\e_TransPort\fR
.RS 4
These underscore\-prefixed options are variants of the regular Port options\&. They behave the same, except they are not saved to the torrc file by the controller\(cqs SAVECONF command\&.
.RE
.SH "SIGNALS"
.sp
Tor catches the following signals:
.PP
\fBSIGTERM\fR
.RS 4
Tor will catch this, clean up and sync to disk if necessary, and exit\&.
.RE
.PP
\fBSIGINT\fR
.RS 4
Tor clients behave as with SIGTERM; but Tor servers will do a controlled slow shutdown, closing listeners and waiting 30 seconds before exiting\&. (The delay can be configured with the ShutdownWaitLength config option\&.)
.RE
.PP
\fBSIGHUP\fR
.RS 4
The signal instructs Tor to reload its configuration (including closing and reopening logs), and kill and restart its helper processes if applicable\&.
.RE
.PP
\fBSIGUSR1\fR
.RS 4
Log statistics about current connections, past connections, and throughput\&.
.RE
.PP
\fBSIGUSR2\fR
.RS 4
Switch all logs to loglevel debug\&. You can go back to the old loglevels by sending a SIGHUP\&.
.RE
.PP
\fBSIGCHLD\fR
.RS 4
Tor receives this signal when one of its helper processes has exited, so it can clean up\&.
.RE
.PP
\fBSIGPIPE\fR
.RS 4
Tor catches this signal and ignores it\&.
.RE
.PP
\fBSIGXFSZ\fR
.RS 4
If this signal exists on your platform, Tor catches and ignores it\&.
.RE
.SH "FILES"
.PP
\fB@CONFDIR@/torrc\fR
.RS 4
The configuration file, which contains "option value" pairs\&.
.RE
.PP
\fB$HOME/\&.torrc\fR
.RS 4
Fallback location for torrc, if @CONFDIR@/torrc is not found\&.
.RE
.PP
\fB@LOCALSTATEDIR@/lib/tor/\fR
.RS 4
The tor process stores keys and other data here\&.
.RE
.PP
\fIDataDirectory\fR\fB/cached\-status/\fR
.RS 4
The most recently downloaded network status document for each authority\&. Each file holds one such document; the filenames are the hexadecimal identity key fingerprints of the directory authorities\&. Obsolete; no longer in use\&.
.RE
.PP
\fIDataDirectory\fR\fB/cached\-certs\fR
.RS 4
This file holds downloaded directory key certificates that are used to verify authenticity of documents generated by Tor directory authorities\&.
.RE
.PP
\fIDataDirectory\fR\fB/cached\-consensus\fR and/or \fBcached\-microdesc\-consensus\fR
.RS 4
The most recent consensus network status document we\(cqve downloaded\&.
.RE
.PP
\fIDataDirectory\fR\fB/cached\-descriptors\fR and \fBcached\-descriptors\&.new\fR
.RS 4
These files hold downloaded router statuses\&. Some routers may appear more than once; if so, the most recently published descriptor is used\&. Lines beginning with @\-signs are annotations that contain more information about a given router\&. The "\&.new" file is an append\-only journal; when it gets too large, all entries are merged into a new cached\-descriptors file\&.
.RE
.PP
\fIDataDirectory\fR\fB/cached\-extrainfo\fR and \fBcached\-extrainfo\&.new\fR
.RS 4
As "cached\-descriptors", but holds optionally\-downloaded "extra\-info" documents\&. Relays use these documents to send inessential information about statistics, bandwidth history, and network health to the authorities\&. They aren\(cqt fetched by default; see the DownloadExtraInfo option for more info\&.
.RE
.PP
\fIDataDirectory\fR\fB/cached\-microdescs\fR and \fBcached\-microdescs\&.new\fR
.RS 4
These files hold downloaded microdescriptors\&. Lines beginning with @\-signs are annotations that contain more information about a given router\&. The "\&.new" file is an append\-only journal; when it gets too large, all entries are merged into a new cached\-microdescs file\&.
.RE
.PP
\fIDataDirectory\fR\fB/cached\-routers\fR and \fBcached\-routers\&.new\fR
.RS 4
Obsolete versions of cached\-descriptors and cached\-descriptors\&.new\&. When Tor can\(cqt find the newer files, it looks here instead\&.
.RE
.PP
\fIDataDirectory\fR\fB/state\fR
.RS 4
A set of persistent key\-value mappings\&. These are documented in the file\&. These include:
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
The current entry guards and their status\&.
.RE
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
The current bandwidth accounting values\&.
.RE
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
When the file was last written
.RE
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
What version of Tor generated the state file
.RE
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
A short history of bandwidth usage, as produced in the server descriptors\&.
.RE
.RE
.PP
\fIDataDirectory\fR\fB/sr\-state\fR
.RS 4
Authority only\&. State file used to record information about the current status of the shared\-random\-value voting state\&.
.RE
.PP
\fIDataDirectory\fR\fB/diff\-cache\fR
.RS 4
Directory cache only\&. Holds older consensuses, and diffs from older consensuses to the most recent consensus of each type, compressed in various ways\&. Each file contains a set of key\-value arguments decribing its contents, followed by a single NUL byte, followed by the main file contents\&.
.RE
.PP
\fIDataDirectory\fR\fB/bw_accounting\fR
.RS 4
Used to track bandwidth accounting values (when the current period starts and ends; how much has been read and written so far this period)\&. This file is obsolete, and the data is now stored in the \*(Aqstate\*(Aq file instead\&.
.RE
.PP
\fIDataDirectory\fR\fB/control_auth_cookie\fR
.RS 4
Used for cookie authentication with the controller\&. Location can be overridden by the CookieAuthFile config option\&. Regenerated on startup\&. See control\-spec\&.txt in
torspec
for details\&. Only used when cookie authentication is enabled\&.
.RE
.PP
\fIDataDirectory\fR\fB/lock\fR
.RS 4
This file is used to prevent two Tor instances from using same data directory\&. If access to this file is locked, data directory is already in use by Tor\&.
.RE
.PP
\fIDataDirectory\fR\fB/key\-pinning\-journal\fR
.RS 4
Used by authorities\&. A line\-based file that records mappings between RSA1024 identity keys and Ed25519 identity keys\&. Authorities enforce these mappings, so that once a relay has picked an Ed25519 key, stealing or factoring the RSA1024 key will no longer let an attacker impersonate the relay\&.
.RE
.PP
\fIDataDirectory\fR\fB/keys/\fR*
.RS 4
Only used by servers\&. Holds identity keys and onion keys\&.
.RE
.PP
\fIDataDirectory\fR\fB/keys/authority_identity_key\fR
.RS 4
A v3 directory authority\(cqs master identity key, used to authenticate its signing key\&. Tor doesn\(cqt use this while it\(cqs running\&. The tor\-gencert program uses this\&. If you\(cqre running an authority, you should keep this key offline, and not actually put it here\&.
.RE
.PP
\fIDataDirectory\fR\fB/keys/authority_certificate\fR
.RS 4
A v3 directory authority\(cqs certificate, which authenticates the authority\(cqs current vote\- and consensus\-signing key using its master identity key\&. Only directory authorities use this file\&.
.RE
.PP
\fIDataDirectory\fR\fB/keys/authority_signing_key\fR
.RS 4
A v3 directory authority\(cqs signing key, used to sign votes and consensuses\&. Only directory authorities use this file\&. Corresponds to the
\fBauthority_certificate\fR
cert\&.
.RE
.PP
\fIDataDirectory\fR\fB/keys/legacy_certificate\fR
.RS 4
As authority_certificate: used only when V3AuthUseLegacyKey is set\&. See documentation for V3AuthUseLegacyKey\&.
.RE
.PP
\fIDataDirectory\fR\fB/keys/legacy_signing_key\fR
.RS 4
As authority_signing_key: used only when V3AuthUseLegacyKey is set\&. See documentation for V3AuthUseLegacyKey\&.
.RE
.PP
\fIDataDirectory\fR\fB/keys/secret_id_key\fR
.RS 4
A relay\(cqs RSA1024 permanent identity key, including private and public components\&. Used to sign router descriptors, and to sign other keys\&.
.RE
.PP
\fIDataDirectory\fR\fB/keys/ed25519_master_id_public_key\fR
.RS 4
The public part of a relay\(cqs Ed25519 permanent identity key\&.
.RE
.PP
\fIDataDirectory\fR\fB/keys/ed25519_master_id_secret_key\fR
.RS 4
The private part of a relay\(cqs Ed25519 permanent identity key\&. This key is used to sign the medium\-term ed25519 signing key\&. This file can be kept offline, or kept encrypted\&. If so, Tor will not be able to generate new signing keys itself; you\(cqll need to use tor \-\-keygen yourself to do so\&.
.RE
.PP
\fIDataDirectory\fR\fB/keys/ed25519_signing_secret_key\fR
.RS 4
The private and public components of a relay\(cqs medium\-term Ed25519 signing key\&. This key is authenticated by the Ed25519 master key, in turn authenticates other keys (and router descriptors)\&.
.RE
.PP
\fIDataDirectory\fR\fB/keys/ed25519_signing_cert\fR
.RS 4
The certificate which authenticates "ed25519_signing_secret_key" as having been signed by the Ed25519 master key\&.
.RE
.PP
\fIDataDirectory\fR\fB/keys/secret_onion_key\fR and \fBsecret_onion_key\&.old\fR
.RS 4
A relay\(cqs RSA1024 short\-term onion key\&. Used to decrypt old\-style ("TAP") circuit extension requests\&. The "\&.old" file holds the previously generated key, which the relay uses to handle any requests that were made by clients that didn\(cqt have the new one\&.
.RE
.PP
\fIDataDirectory\fR\fB/keys/secret_onion_key_ntor\fR and \fBsecret_onion_key_ntor\&.old\fR
.RS 4
A relay\(cqs Curve25519 short\-term onion key\&. Used to handle modern ("ntor") circuit extension requests\&. The "\&.old" file holds the previously generated key, which the relay uses to handle any requests that were made by clients that didn\(cqt have the new one\&.
.RE
.PP
\fIDataDirectory\fR\fB/fingerprint\fR
.RS 4
Only used by servers\&. Holds the fingerprint of the server\(cqs identity key\&.
.RE
.PP
\fIDataDirectory\fR\fB/hashed\-fingerprint\fR
.RS 4
Only used by bridges\&. Holds the hashed fingerprint of the bridge\(cqs identity key\&. (That is, the hash of the hash of the identity key\&.)
.RE
.PP
\fIDataDirectory\fR\fB/v3\-status\-votes\fR
.RS 4
Only for v3 authoritative directory servers\&. This file contains status votes from all the authoritative directory servers\&.
.RE
.PP
\fIDataDirectory\fR\fB/unverified\-consensus\fR
.RS 4
This file contains a network consensus document that has been downloaded, but which we didn\(cqt have the right certificates to check yet\&.
.RE
.PP
\fIDataDirectory\fR\fB/unverified\-microdesc\-consensus\fR
.RS 4
This file contains a microdescriptor\-flavored network consensus document that has been downloaded, but which we didn\(cqt have the right certificates to check yet\&.
.RE
.PP
\fIDataDirectory\fR\fB/unparseable\-desc\fR
.RS 4
Onion server descriptors that Tor was unable to parse are dumped to this file\&. Only used for debugging\&.
.RE
.PP
\fIDataDirectory\fR\fB/router\-stability\fR
.RS 4
Only used by authoritative directory servers\&. Tracks measurements for router mean\-time\-between\-failures so that authorities have a good idea of how to set their Stable flags\&.
.RE
.PP
\fIDataDirectory\fR\fB/stats/dirreq\-stats\fR
.RS 4
Only used by directory caches and authorities\&. This file is used to collect directory request statistics\&.
.RE
.PP
\fIDataDirectory\fR\fB/stats/entry\-stats\fR
.RS 4
Only used by servers\&. This file is used to collect incoming connection statistics by Tor entry nodes\&.
.RE
.PP
\fIDataDirectory\fR\fB/stats/bridge\-stats\fR
.RS 4
Only used by servers\&. This file is used to collect incoming connection statistics by Tor bridges\&.
.RE
.PP
\fIDataDirectory\fR\fB/stats/exit\-stats\fR
.RS 4
Only used by servers\&. This file is used to collect outgoing connection statistics by Tor exit routers\&.
.RE
.PP
\fIDataDirectory\fR\fB/stats/buffer\-stats\fR
.RS 4
Only used by servers\&. This file is used to collect buffer usage history\&.
.RE
.PP
\fIDataDirectory\fR\fB/stats/conn\-stats\fR
.RS 4
Only used by servers\&. This file is used to collect approximate connection history (number of active connections over time)\&.
.RE
.PP
\fIDataDirectory\fR\fB/stats/hidserv\-stats\fR
.RS 4
Only used by servers\&. This file is used to collect approximate counts of what fraction of the traffic is hidden service rendezvous traffic, and approximately how many hidden services the relay has seen\&.
.RE
.PP
\fIDataDirectory\fR\fB/networkstatus\-bridges\fR
.RS 4
Only used by authoritative bridge directories\&. Contains information about bridges that have self\-reported themselves to the bridge authority\&.
.RE
.PP
\fIDataDirectory\fR\fB/approved\-routers\fR
.RS 4
Authorities only\&. This file is used to configure which relays are known to be valid, invalid, and so forth\&.
.RE
.PP
\fIHiddenServiceDirectory\fR\fB/hostname\fR
.RS 4
The <base32\-encoded\-fingerprint>\&.onion domain name for this hidden service\&. If the hidden service is restricted to authorized clients only, this file also contains authorization data for all clients\&.
.RE
.PP
\fIHiddenServiceDirectory\fR\fB/private_key\fR
.RS 4
The private key for this hidden service\&.
.RE
.PP
\fIHiddenServiceDirectory\fR\fB/client_keys\fR
.RS 4
Authorization data for a hidden service that is only accessible by authorized clients\&.
.RE
.PP
\fIHiddenServiceDirectory\fR\fB/onion_service_non_anonymous\fR
.RS 4
This file is present if a hidden service key was created in
\fBHiddenServiceNonAnonymousMode\fR\&.
.RE
.SH "SEE ALSO"
.sp
\fBtorsocks\fR(1), \fBtorify\fR(1)
.sp
\fBhttps://www\&.torproject\&.org/\fR
.sp
\fBtorspec: \fR\fBhttps://spec\&.torproject\&.org\fR\fB \fR
.SH "BUGS"
.sp
Plenty, probably\&. Tor is still in development\&. Please report them at https://trac\&.torproject\&.org/\&.
.SH "AUTHORS"
.sp
Roger Dingledine [arma at mit\&.edu], Nick Mathewson [nickm at alum\&.mit\&.edu]\&.
